/*!
 * 
 */
Ext.ns("itasks.util");

itasks.util.formatDate = function(ts) {
	if (ts == null)
		return "";
	else	
		return Date.parseDate(ts, "U").format("d M Y H:i:s");
};
itasks.util.formatStartDate = function (ts) {
	if (ts == null)
		return "Not started yet";
	else
		return Date.parseDate(ts, "U").format("d M Y H:i");
};
itasks.util.formatDeadline = function(ts) {
	if(ts == null)
		return "No deadline";
	else
		return Date.parseDate(ts, "U").format("d M Y H:i");
};
itasks.util.formatPriority = function(priority) {
	switch(priority) {
		case null : return "";
		case "LowPriority": return "Low";
		case "NormalPriority": return "Normal";
		case "HighPriority": return itasks.util.coloredLabel("red","High");
	}
	return priority;
};
itasks.util.formatProgress = function(progress) {
	switch(progress) {
		case null: return "";
		case "TPActive" : return itasks.util.coloredLabel("green","Active");
		case "TPStuck" : return itasks.util.coloredLabel("purple","Stuck");
		case "TPWaiting": return itasks.util.coloredLabel("blue","Waiting");
		case "TPReject": return itasks.util.coloredLabel("red","Reject");
	}
	return progress;
}
itasks.util.coloredLabel = function (color, msg) {
	return "<span style=\"color: " + color + "; font-weight: bold;\">" + msg + "</span>";
};

itasks.util.formatUser = function (user) {
	/*if (user == "RootUser")
		return "Root user"
	if (user.length == 2 && user[0] == "RegisteredUser")
		return user[1].displayName;
	if (user.length == 2 && user[0] == "NamedUser")
		return user[1];
			
	return "Unknown user type"*/
	return user
}

itasks.util.fieldLabel = function(optional, label) {
	if(optional) {
		return label
	} else {
		return label + "*"
	}
}

//Filter method for arrays (IE does not natively support this method)
if (!Array.prototype.filter)
{
  Array.prototype.filter = function(fun /*, thisp*/)
  {
    var len = this.length;
    if (typeof fun != "function")
      throw new TypeError();

    var res = new Array();
    var thisp = arguments[1];
    for (var i = 0; i < len; i++)
    {
      if (i in this)
      {
        var val = this[i]; // in case fun mutates this
        if (fun.call(thisp, val, i, this))
          res.push(val);
      }
    }

    return res;
  };
};

//Open a preview window for (external) urls
//--- Preview function ---
itasks.util.preview = function(link){
	var vport = Ext.getDoc().getViewSize();
		
	var prevWindow = new Ext.Window(
		{ modal: true
		, width: vport.width*.9
		, height: vport.height*.9
		, title: 'Document Preview'
		, html: '<iframe src="'+link+'" frameborder="0" style="width: 100%; height: 100%; background-color: white"></iframe>'
		}
	);		
	prevWindow.show();
};

//Function to determine scrollbar width
itasks.util.getScrollerWidth =  function() {
/*	var scr = null;
	var inn = null;
	var wNoScroll = 0;
	var wScroll = 0;

	// Outer scrolling div
	scr = document.createElement('div');
	scr.style.position = 'absolute';
	scr.style.top = '-1000px';
	scr.style.left = '-1000px';
	scr.style.width = '100px';
	scr.style.height = '50px';
	// Start with no scrollbar
	scr.style.overflow = 'hidden';

	// Inner content div
	inn = document.createElement('div');
	inn.style.width = '100%';
	inn.style.height = '200px';

	// Put the inner div in the scrolling div
	scr.appendChild(inn);
	// Append the scrolling div to the doc
	document.body.appendChild(scr);

	// Width of the inner div sans scrollbar
	wNoScroll = inn.offsetWidth;
	// Add the scrollbar
	scr.style.overflow = 'auto';
	// Width of the inner div width scrollbar
	wScroll = inn.offsetWidth;

	// Remove the scrolling div from the doc
	document.body.removeChild(
		document.body.lastChild);

	// Pixel width of the scroller
	return (wNoScroll - wScroll);*/
};

Ext.ns("itasks.form");

itasks.form.StaticField = Ext.extend(Ext.form.Field, {

	format: Ext.util.Format.htmlEncode,
	
	initComponent: function() {
		Ext.apply(this,{
			defaultAutoCreate: {tag: "div"},
			style: "padding: 3px 0px 3px 0px"
		});
		itasks.form.StaticField.superclass.initComponent.apply(this,arguments);
	},
	onRender: function(ct, position) {
		itasks.form.StaticField.superclass.onRender.apply(this,arguments);		
		
		if(!this.el) {
			this.el = ct.createChild(this.getAutoCreate(), position);
		}
		this.setValue(this.value);
	},
	setValue: function(value) {
		this.value = value;
		if(this.rendered) {
			this.el.update(this.format(this.value));
		}
	}
});

itasks.form.InlineField = Ext.extend(Ext.Panel, {

	initComponent: function () {
		Ext.apply(this, {
			layout: "card",
			width: 200,
			height: 28,
			style: "margin: 0px",
			border: false,
			value: this.field.value,
			activeItem: 0,
			isFormField: true,
			items: [{
				layout: "column",
				border: false,
				items: [{
					xtype: "panel",
					style: "padding: 3px 0px 5px 0px;",
					border: false,
					columnWidth: 1,
					html: (this.format == undefined) ? this.value : this.format(this.value, this.field)
				},{
					xtype: "toolbar",
					border: false,
					width: 28,
					style: "padding: 0px 0px 0px 2px; background: none; border: 0",
					items: [{
						iconCls: "icon-edit",
						cls: "x-btn-icon",
						handler: this.startEdit,
						scope: this
					}]
				}]				
			},{
				layout: "column",
				border: false,
				items: [{
					xtype: "panel",
					border: false,
					layout: "fit",
					columnWidth: 1,
					items: [Ext.apply(this.field,{value: this.value})]
				},{
					xtype: "toolbar",
					border: false,
					width: 28,
					style: "padding: 0px 0px 0px 2px; background: none; border: 0",
					items: [{
						iconCls: "icon-accept",
						cls: "x-btn-icon",
						handler: this.stopEdit,
						scope: this
					}]
				}]		
			}]
		});
		itasks.form.InlineField.superclass.initComponent.apply(this,arguments);
		
		this.addEvents("startedit","stopedit");
	},
	startEdit: function () {
		//Switch to edit card
		this.layout.setActiveItem(1);
		this.doLayout();
		//Fire startedit event
		this.fireEvent("startedit");
	
	},
	stopEdit: function() {
		
		var field = this.getComponent(1).getComponent(0).getComponent(0);
		var oldValue = this.value;
		var newValue = field.getValue();
		
		this.setValue(newValue);
	
		//Switch to label card
		this.layout.setActiveItem(0);
		this.doLayout();
		//Fire stopedit event
		this.fireEvent("stopedit",oldValue,newValue);
		//Fire change event
		if(oldValue != newValue)
			this.fireEvent("change",oldValue,newValue);
	},
	getValue: function() {
		return this.value;
	},
	setValue: function(value) {
		
		this.value = value;
		
		var panel = this.getComponent(0).getComponent(0);
		var field = this.getComponent(1).getComponent(0).getComponent(0);
		var label = this.format == undefined ? this.value : this.format(this.value, field)
		
		field.setValue(value);
		
		if(panel.rendered)
			panel.getEl().update(label);
		else
			panel.html = label;
	}
});

itasks.form.UserField = Ext.extend(Ext.form.ComboBox,{
	store: new Ext.data.JsonStore({
			root: "users",
			totalProperty: "total",
			fields: ["user","label"],
			//url: itasks.config.serverUrl + "/data/users" //FIX
			url: "/handlers/data/users"
	}),
	valueField: "user",
	displayField: "user",
	tpl: new Ext.XTemplate('<tpl for="."><div class="x-combo-list-item">{user:htmlEncode}</div></tpl>'),
	triggerAction: "all",
	editable: false,
	forceSelection: true,
	initComponent: function () {
		itasks.form.UserField.superclass.initComponent.apply(this,arguments);
		this.addListener("beforequery",function(e) {e.combo.store.baseParams["_session"] = itasks.app.session;});
	}
});

Ext.reg("staticfield", itasks.form.StaticField);
Ext.reg("inlinefield", itasks.form.InlineField);
Ext.reg("itasks.userfield", itasks.form.UserField);

//Global event firing. This may be used by plugins like
//Java applets, Flash or Silverlight components
fireTaskEvent = function(taskid, field, value) {
	
	var ct = Ext.getCmp("taskform-" + taskid);
	if(!ct)
		return;
	
	var wp = ct.findParentByType("itasks.work");
	if(!wp)
		return;
	
	var updates = {}
	updates[field] = value;
	
	wp.sendTaskUpdates(taskid, updates);	
}
Ext.ns("itasks.tui");

itasks.tui.BoolControl = Ext.extend(Ext.form.Checkbox,{
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'span', html: this.value};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
	//	this.allowBlank = this.optional;
		this.checked = this.value == "True";
		
		if(this.value == "") delete this.value;
	
		itasks.tui.BoolControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.BoolControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else{		
			if(value == "True") value = true;
			itasks.tui.BoolControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	},
	
	markError : function(msg){		
		if(this.rendered){
			if(!this.errorIcon){
				this.activeError = msg;
				var elp = this.el.findParent('.x-form-element',5,true) || this.el.findParent('.x-form-field-wrap',5,true);
				if(!elp) return;
				
				this.errorIcon = elp.createChild({cls: 'x-form-invalid-icon'});
				if(this.ownerCt){
					this.ownerCt.on('afterlayout', this.alignErrorIcon(), this);
					this.ownerCt.on('expand', this.alignErrorIcon(), this);
				}
				this.on('resize', this.alignErrorIcon(),this);
				this.on('destroy', function(){ Ext.destroy(this.errorIcon); }, this);
			}		
			
			this.alignErrorIcon();
			this.errorIcon.dom.qtip = msg;
			this.errorIcon.dom.qclass = 'x-form-invalid-tip';
			this.errorIcon.show();
		}else{
			this.errorIcon.show();
		}
	},
	
	unmarkError: function(){		
		if(this.errorIcon){
			this.errorIcon.dom.qtip = '';
			this.errorIcon.hide();
			delete this.activeError;
		}
	},
	
	alignErrorIcon : function(){
		this.errorIcon.alignTo(this.el, 'tl-tr', [2, 0]);
	}
});

Ext.reg("itasks.tui.Bool",itasks.tui.BoolControl);Ext.ns("itasks.tui");

itasks.tui.CharControl = Ext.extend(Ext.form.TextField,{
	width: 40,
	maxLength: 1,
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'overflow: auto', html: this.value};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		if(this.value == "") delete this.value;
		itasks.tui.CharControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.CharControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){		
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.CharControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Char",itasks.tui.CharControl);Ext.ns('itasks.tui');

itasks.tui.ConstructorControl = Ext.extend(Ext.Panel,{
	
	initComponent : function(){

		if(this.fieldLabel == null) delete this.fieldLabel;
		else this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
		this.unstyled = true;
		this.autoHeight = true;
				
		var store = [["","Select..."]];
		
		for(var i=0; i<this.consValues.length; i++){
			store[store.length] = [this.consValues[i],this.consValues[i]];
		}
		
		if(!this.staticDisplay){
			this.consField = new Ext.form.ComboBox({
				name: this.name,
				id: this.id + 'c',
				triggerAction: 'all',
				editable: false,
				store: store,
				value: store[(this.consSelIdx+1)][1],
				hideLabel: true,
				style: 'margin-bottom: 4px',
				msgTarget: 'side',
				valueNotFoundText: 'Value not found...'
			});
		}else{
			this.consField = {
				id : this.id + 'c',
				staticDisplay: true,
				html: store[(this.consSelIdx+1)][1],
				hideLabel: true,
				unstyled: true,
				bodyStyle: 'margin-bottom: 4px'
			}
		}
		
		this.consField.setValue = function(value){
			if(this.staticDisplay){
				if(value == "") value = "Select...";				
				if(this.el) this.el.dom.innerHTML = value;
			}else{
				Ext.form.ComboBox.superclass.setValue.call(this,value);
				if(value == "" ) this.setRawValue("Select...");
			}
		};		
		
		var panelItems = this.items.slice(0); //copy the items into another array
		delete this.items;
		
		this.itemPanel = new Ext.Panel(
		{ layout: 'form'
		, autoHeight: true
		, items: panelItems
		, frame: true
		, baseCls: 'x-constructor-panel'
		});
		
		
		this.itemPanel.markHint = function (msg){
			if(this.errorIcon && this.errorIcon.isVisible()) return;
		
			if(this.rendered){
				if(!this.hintIcon){				
					this.hintIcon = this.el.createChild({cls: 'x-record-hint-icon'}, this.body.dom);	
					this.hintIcon.setVisibilityMode(Ext.Element.DISPLAY);
				}

				this.hintIcon.dom.innerHTML = msg;
				this.hintIcon.setVisible(true);					
			}
		};
		
		this.itemPanel.markError = function(msg){
			if(this.rendered){
				if(this.hintIcon) this.hintIcon.hide();
			}	
			
			if(!this.errorIcon){			
				this.errorIcon = this.el.createChild({cls: 'x-record-invalid-icon'}, this.body.dom);
				this.errorIcon.setVisibilityMode(Ext.Element.DISPLAY);
			}
			
			this.errorIcon.dom.innerHTML = msg;
			this.errorIcon.setVisible(true);
		};
		
		this.itemPanel.clearHint = function(){
			if(this.hintIcon) this.hintIcon.setVisible(false);
		};
		
		this.itemPanel.clearError = function(){
			if(this.errorIcon) this.errorIcon.setVisible(false);
		};
			
		this.itemPanel.on('add',function(){ this.showOrHide(); },this.itemPanel);
		this.itemPanel.on('remove', function(){ this.showOrHide();  },this.itemPanel);
		
		this.itemPanel.showOrHide = function(){			
			(function() {
				if((this.items && this.items.length > 0) || (this.errorIcon && this.errorIcon.isVisible()) || (this.hintIcon && this.hintIcon.isVisible())){
					this.show();
				}else{
					this.hide();
				}
			}).defer(50,this);
		};		
		
		this.items = [this.consField, this.itemPanel] //[this.consField].concat(this.items);	
			
		itasks.tui.ConstructorControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.ConstructorControl.superclass.afterRender.call(this,arguments);
	
		(function(){
			this.itemPanel.showOrHide();			
			
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
			
			this.add = function(obj){
				return this.itemPanel.add(obj);
			}
		}).defer(50,this);
	},
	
	setError: function(msg){
		if(this.staticDisplay) return;
		
		(function(){
			if(msg == "") this.itemPanel.clearError();
			else this.itemPanel.markError(msg);
			this.itemPanel.showOrHide();
		}).defer(50,this);
	},
	
	setHint: function(msg){
		if(this.staticDisplay) return;
		
		(function(){
			if(msg == "") this.itemPanel.clearHint();
			else this.itemPanel.markHint(msg);
			this.itemPanel.showOrHide();
		}).defer(50,this);
	}
});

Ext.reg('itasks.tui.Constructor',itasks.tui.ConstructorControl);Ext.ns("itasks.tui");

itasks.tui.CurrencyControl = Ext.extend(Ext.form.TextField,{
	width: 100,
	fieldClass: "x-form-field x-form-num-field",
	style: "text-align: right",
	initEvents: function () {
		this.maskRe = new RegExp('[0123456789\\.]');
		itasks.tui.CurrencyControl.superclass.initEvents.call(this);
	},
	initComponent: function() {
		if(this.staticDisplay){			
			this.autoCreate = {tag: 'div', style: 'overflow: auto; padding-top: 4px', html: this.value};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		if(this.value == "") delete this.value;
		itasks.tui.CurrencyControl.superclass.initComponent.apply(this,arguments);
	},
	onRender: function(ct, position) {
		itasks.tui.CurrencyControl.superclass.onRender.call(this,ct,position);
		//Overlay currency symbol on top of input
		var cl = ct.createChild({tag: 'span', style: 'position: absolute;', cn: this.currencyLabel});
		cl.setLocation(this.getEl().getLeft() + 5, this.getEl().getTop() + 5);
	},
	afterRender: function(){
		itasks.tui.CurrencyControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	normalize: function(s) {
		if(s == "")
			return s;
		
		var padl = function(x) {
			return (x.length == 0) ? "0" : x;
		}
		var padr = function(x) {
			if(x.length == 0) return "00";
			if(x.length == 1) return x + "0";
			return x[0] + x[1];
		}
		
		var parts = s.split('.');
		
		if(parts.length == 1)
			return s + ".00";
		else
			return padl(parts[0]) + "." + padr(parts[1]);
		
	},
	beforeBlur: function() {
		this.setValue(this.normalize(this.getRawValue()));
	},
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.CurrencyControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	setError: function(msg){		
		(function() {
			if(msg == "") this.clearInvalid();
			else this.markInvalid(msg);
		}).defer(50,this);
	},
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Currency",itasks.tui.CurrencyControl);Ext.ns("itasks.tui");

itasks.tui.DateControl = Ext.extend(Ext.form.DateField,{
	format: "d-m-Y",
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'padding-top: 4px', html: this.value};
		}
		
		this.msgTarget = 'side';
			
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		
		itasks.tui.DateControl.superclass.initComponent.apply(this,arguments);		
	},
	//getValue: function() {
		//return this.getRawValue();
	//},
	afterRender: function(ct,position){		
		itasks.tui.DateControl.superclass.afterRender.call(this,ct,position);

		if(this.staticDisplay){
			this.el.next().remove();		
		}	
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.DateControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Date",itasks.tui.DateControl);Ext.ns('itasks.tui');

itasks.tui.DocumentControl = Ext.extend(Ext.Panel,
{	
	initComponent : function(){
		
		if(this.fieldLabel == null) delete this.fieldLabel;
		else this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
		this.uploadPanel = new itasks.tui.document.UploadPanel({name: this.name});
		this.downloadPanel = new itasks.tui.document.DownloadPanel();
		
		Ext.apply(this,
		{ unstyled: true
		, width: 500
		, layout: 'card'
		, activeItem: 0
		, autoHeight: true
		, items: [
				this.uploadPanel,
				this.downloadPanel
			]
		});
	
		itasks.tui.DocumentControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender : function(arguments){
		itasks.tui.DocumentControl.superclass.afterRender.call(this,arguments);
		
		if(this.staticDisplay){
			if(this.document.size != 0){
				this.showDownloadPanel(true);
			}else{
				this.removeAll();
				this.add({html: 'Empty Document', unstyled: true});
			}				
		}else if(this.document.size != 0){
			this.showDownloadPanel(false);
		}else{
			this.showUploadPanel(false);
		}
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
		
		this.doLayout();
	},
	
	showDownloadPanel : function(isStatic){
		this.downloadPanel.updateDocInfo(this.document);
		this.downloadPanel.setStaticDisplay(isStatic);
		this.getLayout().setActiveItem(1);
	},
	
	showUploadPanel : function(showCancel){
		this.uploadPanel.showCancel(showCancel);
		this.getLayout().setActiveItem(0);
	},
	
	setError: function(msg){
		if(this.staticDisplay) return;
		
		(function(){
			this.uploadPanel.setError(msg);
			this.downloadPanel.setError(msg);
		}).defer(30,this);
	},
	
	setHint: function(msg){
		if(this.staticDisplay) return;
		
		(function(){
			this.uploadPanel.setHint(msg);
			this.downloadPanel.setHint(msg);
		}).defer(70,this);
	},
	
	setValue: function(value){
		if(!this.rendered) return;
		
		this.document = Ext.decode(value);
	
		if(this.document.size == 0){
			this.showUploadPanel(false);
		}else{
			this.showDownloadPanel(false);
		}
	}
});

Ext.ns('itasks.tui.document');

itasks.tui.document.DownloadPanel = Ext.extend(Ext.form.FormPanel,{
	
	initComponent: function(){
		this.dlButton = new Ext.Button(
			{ text : ''
			, qtip : 'Download'
			, iconCls : 'x-form-document-download-icon'
			, handler: this.dlButtonHandler
			});
		
		this.editButton = new Ext.Button(
			{ text : ''
			, qtip : 'Edit'
			, iconCls : 'x-form-document-edit-icon'
			, handler : this.editButtonHandler
			});
			
		this.trashButton = new Ext.Button(
			{ text : ''
			, qtip : 'Remove'
			, iconCls : 'x-form-document-trash-icon'
			, handler : this.trashButtonHandler
			});
			
		this.errorIcon = new Ext.Panel({cls: 'x-document-invalid-icon', width: 25, unstyled: true, hidden: true});
		this.hintIcon = new Ext.Panel({cls: 'x-document-hint-icon', width: 25, unstyled: true, hidden: true});
			
		Ext.apply(this,
		{ layout : 'hbox'
		, unstyled : true
		, fileUpload : true
		, height: 24
		, items : [
			{ width: 16
			, height: 16
			, xtype: 'panel'
			, unstyled: true
			},
			{ xtype: 'displayfield'
			, width: 262
			, height: 24
			, autoHeight: true
			, style: 'padding: 4px'
			},
			this.editButton,
			this.trashButton,
			this.dlButton,
			this.hintIcon,
			this.errorIcon
			]
		});
		
		itasks.tui.document.DownloadPanel.superclass.initComponent.apply(this,arguments);
	},
	
	setStaticDisplay : function(isStatic){
		this.editButton.setVisible(!isStatic);
		this.trashButton.setVisible(!isStatic);
		this.dlButton.setVisible(!isStatic);
	},
	
	updateDocInfo: function(docInfo){
		this.document = docInfo;
		
		var fn = this.document.name;
		var fs = this.printFileSize(this.document.size);
		
		this.get(1).setValue(fn+" ("+fs+")");
		
		this.get(0).cls = '';
		this.get(0).addClass(this.iconMimeType(this.document.mime));
	},
	
	iconMimeType: function(mime){
	
		if(mime.match("application/pdf")){
			return('file-type-application-pdf-icon');
		}
		else if(mime.match('^image')){
			return('file-type-image-icon');
		}
		else if(mime.match("^text")){
			return('file-type-text-icon');
		}
		else if(mime.match("^application")){
			return('file-type-application-icon');
		}
		else if(mime.match("^audio")){
			return('file-type-audio-icon');
		}
		else if(mime.match("^video")){
			return('file-type-video-icon');
		}
		else{
			return('file-type-plain-icon');
		}
	},
	
	printFileSize: function(size){
		if(size > 1048576){
			return (size/1048576).toFixed(1)+" Mbytes"
		}else if(size > 1024){
			return (size/1024).toFixed(1)+" Kbytes"
		}else{
			return size+" bytes"
		}
	},
	
	setError : function(msg){
		if(this.rendered){
			if(msg == '' || msg == null){
				this.errorIcon.hide();
			}else{
				this.hintIcon.hide();
				this.errorIcon.show();
				if(this.errorIcon.el) this.errorIcon.el.dom.qtip = msg;
				if(this.errorIcon.el) this.errorIcon.el.dom.qclass = 'x-form-invalid-tip'
			}
		}	
		
		this.doLayout();
	},
	
	setHint : function(msg){
		if(this.rendered){
			if(msg == '' || msg == null || this.errorIcon.isVisible()){
				this.hintIcon.hide();
			}else{
				this.hintIcon.show();
				if(this.hintIcon.el) this.hintIcon.el.dom.qtip = msg;
				if(this.hintIcon.el) this.hintIcon.el.dom.qclass = 'x-form-hint-tip'
			}
		}	
		
		this.doLayout();
	},
	
	dlButtonHandler: function(src, evt){
		var form = this.findParentByType('itasks.tui.document.Download');
		var dp = this.findParentByType('itasks.tui.Document');
		var wt = this.findParentByType('itasks.work');
		
		if(form.getForm().isValid()){
			form.getForm().submit({
			
				url: "/services/json/documents/" + dp.document.documentId + "/download",
				params: { session : itasks.app.session },
				waitMsg: null,
				failure: function(form, o){
					Ext.Msg.alert('Error',o.result.errors,function(){wt.refresh()});
				}
			});
		}
	},
	
	editButtonHandler: function(src, evt){
		this.findParentByType('itasks.tui.Document').showUploadPanel(true);
	},
	
	trashButtonHandler: function(src, evt){
	
		var tf = this.findParentByType(itasks.ttc.FormContainer);
		var dp = this.findParentByType('itasks.tui.Document');
	
		tf.addUpdate(dp.name,"");
		tf.sendUpdates(false);
	},
	
	setValue: function(value){
		this.ownerCt.setValue(value);
	}
});

itasks.tui.document.UploadPanel = Ext.extend(Ext.form.FormPanel,{

	initComponent: function(){
	
		this.cancelButton = new Ext.Button(
			{ text : ''
			, iconCls: 'x-form-document-cancel-icon'
			, handler: this.cancelButtonHandler			
			});
			
		this.errorIcon = new Ext.Panel({cls: 'x-document-invalid-icon', width: 25, unstyled: true, hidden: true});
		this.hintIcon = new Ext.Panel({cls: 'x-document-hint-icon', width: 25, unstyled: true, hidden: true});
			
		Ext.apply(this,
		{ fileUpload: true
		, unstyled: true
		, layout: 'hbox'
		, autoHeight: true
		, items: [
			{ xtype: 'fileuploadfield'
			, width: 300
			, id: 'form-file-'+this.id+'-'+this.name
			, emptyText: 'Select a document'
			, name: 'document'
			, buttonText: ''
			, buttonCfg: { iconCls: 'x-form-document-browse-icon' }
			, listeners: { fileselected : this.uplHandler }
			},
			this.cancelButton,
			this.hintIcon,
			this.errorIcon
			]
		});
		
		itasks.tui.document.UploadPanel.superclass.initComponent.apply(this,arguments);
	},
	
	setError : function(msg){
		if(this.rendered){
			if(msg == '' || msg == null){
				this.errorIcon.hide();
			}else{
				this.hintIcon.hide();
				this.errorIcon.show();
				if(this.errorIcon.el) this.errorIcon.el.dom.qtip = msg;
				if(this.errorIcon.el) this.errorIcon.el.dom.qclass = 'x-form-invalid-tip'
			}
		}	
		
		this.doLayout();
	},
	
	setHint : function(msg){
		if(this.rendered){
			if(msg == '' || msg == null || this.errorIcon.isVisible()){
				this.hintIcon.hide();
			}else{
				this.hintIcon.show();
				if(this.hintIcon.el) this.hintIcon.el.dom.qtip = msg;
				if(this.hintIcon.el) this.hintIcon.el.dom.qclass = 'x-form-hint-tip'
			}
		}	
		
		this.doLayout();
	},
	
	showCancel: function(cancel){
		this.cancelButton.setVisible(cancel);
	},
	
	uplHandler : function(src,evt){
	
		var form = this.findParentByType("itasks.tui.document.Upload");
		var tf = this.findParentByType(itasks.ttc.FormContainer);
		var dp = this.findParentByType("itasks.tui.Document");
						
		if(form.getForm().isValid()){				
			form.getForm().submit({
				url: "/services/json/documents/upload",
				
				params: { session : itasks.app.session },
				waitMsg: "Uploading document. Please wait..",
				success: function(form,response) {
						try {
							var resp = Ext.decode(response.response.responseText);
							
							tf.addUpdate(dp.name, resp.documents[0].documentId);
							tf.sendUpdates(false);
						} catch(e) {
							itasks.app.restart("Document transaction failed");
							return;
						}
					},
				failure: function(form,response) {
						itasks.app.restart("Document transaction failed");
						return;
					}					
			});
		}
	},
	cancelButtonHandler: function(src,evt){
		var form = this.findParentByType('itasks.tui.Document');
		form.showDownloadPanel(false);
	},
	
	setValue: function(value){
		this.ownerCt.setValue(value);
	}
});

Ext.reg("itasks.tui.Document",itasks.tui.DocumentControl);
Ext.reg("itasks.tui.document.Download",itasks.tui.document.DownloadPanel);
Ext.reg("itasks.tui.document.Upload",itasks.tui.document.UploadPanel);
Ext.ns("itasks.tui");

itasks.tui.IntControl = Ext.extend(Ext.form.NumberField,{
	width: 100,
	allowDecimals: false,
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'overflow: auto', html: this.value};
		}
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
	//	this.allowBlank = this.optional;
		
		this.msgTarget = 'side';
				
		if(this.value == "") delete this.value;
		itasks.tui.IntControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.IntControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.IntControl.superclass.setValue.call(this,value);
			if(this.activeError) this.setError(this.activeError);
		}
	},

	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Int",itasks.tui.IntControl);Ext.ns("itasks.tui");

itasks.tui.NoteControl = Ext.extend(Ext.form.TextArea,{
	width: 400,
	grow: true,
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'width:330px; overflow: auto', html: this.value.replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1<br>$2')};
			this.autoHeight = true;
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		if(this.value == "") delete this.value;
		itasks.tui.NoteControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.NoteControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
		
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value.replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1<br>$2'));
		}else{
			itasks.tui.NoteControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Note",itasks.tui.NoteControl);Ext.ns("itasks.tui");

itasks.tui.FormattedTextControl = Ext.extend(Ext.form.HtmlEditor,{
	initComponent: function() {
		
		if(this.fieldLabel == null) delete this.fieldLabel;
		else this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
		Ext.apply(this, {
		//	allowBlank: this.optional,
			width: 700,
			height: 300,
			// ids for selection marker elements
			selectionStartElId: this.id + '_marker-start',
			selectionEndElId: this.id + '_marker-end',
			acceptNewValue: true,
			suspendUpdate: false,
			mouseDown: false
		});
		itasks.tui.FormattedTextControl.superclass.initComponent.apply(this,arguments);
		
		this.addEvents('update');
		var sendUpdate = new Ext.util.DelayedTask(function() {
			this.acceptNewValue = true;
			// suspend updates because events are triggered by this function's changes
			this.suspendUpdate = true;
			
			var doc = this.getDoc();
			var sel = Ext.isIE ? new DOMSelection(doc) : this.getWin().getSelection();
			var origRange = sel.getRangeAt(0);
			if (origRange.collapsed) {
				// no selection, insert start marker at cursor
				this.insertAtCursor("<markerstart id=\"" + this.selectionStartElId + "\"></markerstart>");
			} else {
				// create start/end markers
				var startEl = doc.createElement('markerstart');
				startEl.id = this.selectionStartElId;
				//startEl.setAttribute('class', 'marker-start');
				var endEl = doc.createElement('markerend');
				endEl.id = this.selectionEndElId;
				//endEl.setAttribute('class', 'marker-end');
				
				// get start/end point of current selection
				var startRange = origRange.cloneRange();
				var endRange = origRange.cloneRange();
				startRange.collapse(true);
				endRange.collapse(false);
				
				// insert markers & sync
				endRange.insertNode(endEl);
				startRange.insertNode(startEl);
				this.syncValue();
				
				// restore original selection
				sel.removeAllRanges();
				sel.addRange(origRange);
			}
			
			// send update & remove markers afterwards
			this.fireEvent('update');
			this.removeMarker(this.selectionStartElId);
			this.removeMarker(this.selectionEndElId);
			this.suspendUpdate = false;
		}, this);
		
		this.on('sync', function(editor) {
			if (!this.suspendUpdate && !this.mouseDown) {
				// ignore new values from server because content of editor has changed in meantime
				this.acceptNewValue = false;
				sendUpdate.delay(500);
			}
		});
	},
	
	initEditor: function() {
		itasks.tui.FormattedTextControl.superclass.initEditor.apply(this,arguments);
		
		doc = this.getDoc();
		// don't send update on mousedown to prevent problems with making selection using the mouse
		Ext.EventManager.addListener(doc, 'mousedown', function(){this.mouseDown = true;}, this);
		Ext.EventManager.addListener(doc, 'mouseup', function(){this.mouseDown = false; this.onEditorEvent();}, this);
		
		this.tb.setVisible(this.tb.items.length > 0); // hide toolbar without controls
		this.computeMarkers(); // compute markers in initial value
	},
	
	removeMarker: function(id) {
		var doc = this.getDoc();
		var markerNode = doc.getElementById(id);
		
		if(markerNode) {
			if(markerNode.firstChild) {
				// don't remove content of node
				markerNode.parentNode.replaceChild(markerNode.firstChild, markerNode);
			} else
				markerNode.parentNode.removeChild(markerNode);
		}
	},
	
	getValue: function() {
		return this.getRawValue();
	},
	
	setValue: function() {
		if (!this.acceptNewValue)
			return;
			
		itasks.tui.FormattedTextControl.superclass.setValue.apply(this,arguments);
		this.computeMarkers();
	},
	
	computeMarkers: function() {
		// search for selection markers
		var startNode = this.getDoc().getElementById(this.selectionStartElId);
		var endNode = this.getDoc().getElementById(this.selectionEndElId);
		if(startNode)
			if(endNode)
				this.setSelection(startNode, endNode);
			else
				// no end-marker, set cursor to start-marker
				this.setSelection(startNode, startNode);
		
		// remove markers to prevent problems with selection boundaries inside of them
		this.removeMarker(this.selectionStartElId);
		this.removeMarker(this.selectionEndElId);
	},
	
	setSelection: function(start, end) {
		// set selection from start to end element
		var doc = this.getDoc();
		var sel = Ext.isIE ? new DOMSelection(doc) : this.getWin().getSelection();
		sel.removeAllRanges();
		
		var range = Ext.isIE ? new DOMRange(doc) : doc.createRange();
		range.setStartAfter(start);
		range.setEndAfter(end);
		if (Ext.isIE)
			TextRangeUtils.convertFromDOMRange(range).select();
		else
			sel.addRange(range);
	}
});

Ext.reg("itasks.tui.FormattedText",itasks.tui.FormattedTextControl);Ext.ns("itasks.tui");

itasks.tui.SourceCodeControl = Ext.extend(Ext.form.TextArea, {
    language: 'txt',
    codeMirrorPath: 'CodeMirror-0.67', // should be path to code mirror on your server!
    initComponent: function() {
        if (this.codeMirrorPath === null) {
            throw 'itasks.tui.SourceCodeControl: codeMirrorPath required';
        }
        this.initialized = false;
        itasks.tui.SourceCodeControl.superclass.initComponent.apply(this, arguments);
		this.on('change', function(){console.log(123);});
        this.addEvents('initialize');
		this.addEvents('update');
        this.on({
            resize: function(ta, width, height) {
                var el = Ext.select('.'+this.id, true);
                if (el){
                //width -= 35;
                    
                            for (var i=0; i< el.elements.length; i++)
                            {
                            el.elements[i].setSize(width, height);
                            }
                }
                if (el) {
                    width -= 35;
                    /* Doesn't work in ie.
                    el.elements.forEach(function(e) {
                        e.setSize(width, height);
                    });*/
                }
            },
            afterrender: function() {
                var parser, stylesheet;
                switch (this.language.toLowerCase()) {
                    case 'css':
                        parser = 'parsecss.js';
                        stylesheet = this.codeMirrorPath+'/css/csscolors.css';
                        break;
                    case 'js':
                        parser = ['tokenizejavascript.js', 'parsejavascript.js'];
                        stylesheet = this.codeMirrorPath+'/css/jscolors.css';
                        break;
					case 'clean':
                        parser = ['tokenizeclean.js', 'parseclean.js'];
                        stylesheet = this.codeMirrorPath+'/css/cleancolors.css';
                        break;
                    case 'php':
                        parser = [
                            "parsexml.js",
                            "parsecss.js",
                            "tokenizejavascript.js",
                            "parsejavascript.js",
                            "../contrib/php/js/tokenizephp.js",
                            "../contrib/php/js/parsephp.js",
                            "../contrib/php/js/parsephphtmlmixed.js"
                        ];
                        stylesheet = [
                            this.codeMirrorPath+'/css/xmlcolors.css',
                            this.codeMirrorPath+'/css/jscolors.css',
                            this.codeMirrorPath+'/css/csscolors.css',
                            this.codeMirrorPath+'/contrib/php/css/phpcolors.css'
                        ];
                        break;
                    case 'htm':
                    case 'html':
                    case 'xml':
                        parser = 'parsexml.js';
                        stylesheet = 'xmlcolors.css';
                        break;
                    default:
                        parser = 'parsedummy.js';
                        stylesheet = '';
                        break;
                    
                }
                var me = this;
                                (function() {
                me.codeEditor = new CodeMirror.fromTextArea(me.id, {
                    parserfile: parser,
                    stylesheet: stylesheet,
                    path: me.codeMirrorPath+'/js/',
                    textWrapping: false,
                    lineNumbers: true,
                    iframeClass: 'codemirror-iframe '+me.id,
                    content: this.value,
                    initCallback: function() {
                        me.initialized = true;
						me.setValue(me.value);
                        me.fireEvent('initialize', true);
                    },
					onChange: function() {
						var sendUpdate = new Ext.util.DelayedTask(function() {
							me.lastValue = me.getValue();
							me.fireEvent('update');
						});
						
						sendUpdate.delay(750);
					},
					width: '700px',
					height: '300px'
                });
                            }).defer(100);                
            }
        });
    },
    getValue: function() {
        if (this.initialized) {
            return this.codeEditor.getCode();
        }
        return this.value;    
    },
    setValue: function(v) {
        if (this.initialized && v != this.lastValue) {
            this.codeEditor.setCode(v);
        }
    },
    validate: function() {
        this.getValue();
        itasks.tui.SourceCodeControl.superclass.validate.apply(this, arguments);
    }
});

Ext.reg('itasks.tui.SourceCode', itasks.tui.SourceCodeControl);Ext.ns("itasks.tui");

itasks.tui.ColorChooser = Ext.extend(Ext.ColorPalette, {
	initComponent: function() {
		Ext.apply(this, {
			hideLabel: this.fieldLabel == null,
			fieldLabel: itasks.util.fieldLabel(this.optional, this.fieldLabel),
			allowBlank: this.optional,
			style: {width: '150px'}
		});
		itasks.tui.ColorChooser.superclass.initComponent.apply(this,arguments);
	},
	getValue: function() {
		return this.value;
	}
});

Ext.reg("itasks.tui.ColorChooser", itasks.tui.ColorChooser);Ext.ns('itasks.tui');

itasks.tui.PasswordControl = Ext.extend(Ext.form.TextField,{
	width: 100,
	fieldClass: 'x-form-field',

	initComponent: function(){
		if(this.staticDisplay){
			this.autoCreate = {tag: 'span', html: '***********'};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		this.inputType = 'password';
		
		if(this.value == "") delete this.value;
		
		itasks.tui.PasswordControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.PasswordControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){		
		if(this.staticDisplay){
			this.update('***********');
		}else{
			itasks.tui.PasswordControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}

});

Ext.reg('itasks.tui.Password',itasks.tui.PasswordControl);Ext.ns("itasks.tui");

itasks.tui.RealControl = Ext.extend(Ext.form.NumberField,{
	width: 100,
	allowDecimals: true,
	decimalPrecision: 20, //Maximum precision
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'overflow: auto', html: this.value};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		if(this.value == "") delete this.value;
		itasks.tui.RealControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.RealControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.RealControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Real",itasks.tui.RealControl);Ext.ns("itasks.tui");

itasks.tui.StringControl = Ext.extend(Ext.form.TextField,{
	width: 330,
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'overflow: auto', html: this.value};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;	
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		this.allowBlank = true;
		if(this.value == "") delete this.value;
		itasks.tui.StringControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.StringControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){		
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.StringControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.String",itasks.tui.StringControl);Ext.ns("itasks.tui");

itasks.tui.TimeControl = Ext.extend(Ext.form.TimeField,{
	format: "H:i:s",
	width: 100,
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'div', style: 'padding-top: 4px', html: this.value};
		}
		
		this.msgTarget = 'side';
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		if(this.value == "") delete this.value;
		itasks.tui.TimeControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(ct,position){		
		itasks.tui.TimeControl.superclass.afterRender.call(this,ct,position);

		if(this.staticDisplay){
			this.el.next().remove();		
		}	
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else{
			itasks.tui.TimeControl.superclass.setValue.call(this,value);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	}
});

Ext.reg("itasks.tui.Time",itasks.tui.TimeControl);Ext.ns("itasks.tui");

itasks.tui.UsernameReader = new Ext.data.JsonReader();
itasks.tui.UsernameReader.readRecords = function(o) {
	var UsernameRecord = Ext.data.Record.create(["username"]);	
	var usernames = [];
	for(var i = 0, len = o.users.length; i < len; i++) {
		
		usernames[usernames.length] = new UsernameRecord({username: o.users[i]});
	}
	return {success: true, records: usernames, totalRecords: usernames.length};
}

itasks.tui.UsernameControl = Ext.extend(Ext.form.ComboBox,{
	store: {
		url: "/services/json/users/names",
		reader: itasks.tui.UsernameReader
	},
	valueField: "username",
	displayField: "username",
	tpl: new Ext.XTemplate('<tpl for="."><div class="x-combo-list-item">{username:htmlEncode}</div></tpl>'),
	triggerAction: "all",
	listeners: {
		"beforequery": function(e) {
			e.combo.store.baseParams["session"] = itasks.app.session;
			delete e.combo.lastQuery;
		}
	},
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: "span", html: this.value};
		}
		
		this.msgTarget = "side";
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		//this.allowBlank = this.optional;
		if(this.value == "") delete this.value;
		itasks.tui.UsernameControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(ct,position){		
		itasks.tui.TimeControl.superclass.afterRender.call(this,ct,position);

		if(this.staticDisplay){
			this.el.next().remove();		
		}	
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},	
	
	setValue: function(value){
		if(this.staticDisplay){
			if(this.el) this.el.dom.innerHTML = value;
		}else{
			itasks.tui.UsernameControl.superclass.setValue.call(this,value);
		}
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") itasks.tui.common.clearError(this);
			else itasks.tui.common.markError(this,msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") itasks.tui.common.clearHint(this);
			else itasks.tui.common.markHint(this,msg);
		}).defer(50,this);
	},
	
	getPreferredWidth : function(){
		return 150;
	},
	
	setPreferredWidth : function(width){
		this.setWidth(width);
	}
});

Ext.reg("itasks.tui.Username",itasks.tui.UsernameControl);Ext.ns("itasks.tui");

itasks.tui.HiddenControl = Ext.extend(Ext.Component,{
	initComponent: function() {
		
		this.autoCreate = {tag: 'div', html: this.value};
		
		this.hideLabel = true;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		this.hidden = true;
		
		itasks.tui.HiddenControl.superclass.initComponent.apply(this,arguments);
	}
});

Ext.reg("itasks.tui.Hidden",itasks.tui.HiddenControl);Ext.ns("itasks.tui");

itasks.tui.FormButtonControl = Ext.extend(Ext.Button,{
	initComponent: function() {
		if(this.staticDisplay){
			this.autoCreate = {tag: 'span', html: this.value};
		}
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
		this.enableToggle = true;
		this.allowDepress = true;
		this.pressed = this.value == "True";
	
		this.text = this.label;
		this.iconCls = this.icon;
		
		this.on('toggle',function(button,pressed){
			this.value = (pressed)?"true":"";
		});
	
		itasks.tui.FormButtonControl.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.FormButtonControl.superclass.afterRender.call(this,arguments);
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	setValue: function(value){
		if(this.staticDisplay){
			this.update(value);
		}else if(value == "True"){
			this.toggle(true,true);
		}else{
			this.toggle(false,true);
		}
		
		if(this.activeError) this.setError(this.activeError);
	},
	
	setError: function(msg){		
		(function() {
			if(msg == "") this.clearError();
			else this.markError(msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		(function() {
			if(msg == "") this.clearHint();
			else this.markHint(msg);
		}).defer(50,this);
	},
	
	markError : function(msg){		
		if(this.rendered){
			if(!this.errorIcon){
				this.activeError = msg;
				var elp = this.el.findParent('.x-form-element',5,true) || this.el.findParent('.x-form-field-wrap',5,true);
				if(!elp) return;
				
				this.errorIcon = elp.createChild({cls: 'x-form-invalid-icon'});
				if(this.ownerCt){
					this.ownerCt.on('afterlayout', this.alignErrorIcon(), this);
					this.ownerCt.on('expand', this.alignErrorIcon(), this);
				}
				this.on('resize', this.alignErrorIcon(),this);
				this.on('destroy', function(){ Ext.destroy(this.errorIcon); }, this);
			}
			
			this.alignErrorIcon();
			this.errorIcon.dom.qtip = msg;
			this.errorIcon.dom.qclass = 'x-form-invalid-tip';
			this.errorIcon.show();
		}
	},
	
	markHint : function(msg){		
		if(this.rendered){
			if(!this.hintIcon){
				this.activeHint = msg;
				var elp = this.el.findParent('.x-form-element',5,true) || this.el.findParent('.x-form-field-wrap',5,true);
				if(!elp) return;
				
				this.hintIcon = elp.createChild({cls: 'x-form-hint-icon'});
				if(this.ownerCt){
					this.ownerCt.on('afterlayout', this.alignHintIcon(), this);
					this.ownerCt.on('expand', this.alignHintIcon(), this);
				}
				this.on('resize', this.alignHintIcon(),this);
				this.on('destroy', function(){ Ext.destroy(this.hintIcon); }, this);
			}
			
			this.alignHintIcon();
			this.hintIcon.dom.qtip = msg;
			this.hintIcon.dom.qclass = 'x-form-hint-tip';
			this.hintIcon.show();
		}
	},
	
	clearHint: function(){		
		if(this.hintIcon){
			this.hintIcon.dom.qtip = '';
			this.hintIcon.hide();
			delete this.activeHint;
		}
	},
	
	clearError: function(){		
		if(this.errorIcon){
			this.errorIcon.dom.qtip = '';
			this.errorIcon.hide();
			delete this.activeError;
		}
	},
	
	alignErrorIcon : function(){
		this.errorIcon.alignTo(this.el, 'tl-tr', [2, 0]);
	},
	
	alignHintIcon : function(){
		this.hintIcon.alignTo(this.el, 'tl-tr', [2,0]);
	}
});

Ext.reg("itasks.tui.FormButton",itasks.tui.FormButtonControl);Ext.ns('itasks.tui');

itasks.tui.ChoiceControl = Ext.extend(Ext.form.CheckboxGroup,{

	blankText : 'Please select at least one option',

	initComponent : function(){
		if(this.staticDisplay) {
			//...
		}
		
		this.hideLabel = this.fieldLabel == null;
		this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
		itasks.tui.ChoiceControl.superclass.initComponent.call(this);
	},
	
	onRender: function(ct, position){
		var me = this;
		
		
		if(!this.el && !this.staticDisplay){
			var panelCfg = {
				autoEl : { id: this.id },
				renderTo: ct,
				bufferResize: false,
				layout: 'auto',
				cls: (this.allowMultiple)?'x-form-check-group':'x-form-radio-group',
				style: 'border: none'
			};
			
			var items = [];
			
			var isSelected = function(idx){
				for(var i=0; i<me.selection.length; i++){
					if(idx == me.selection[i]) return true;
				}
				
				return false;
			};
			
			//build the subitems based on 'allowMultiple': true = checkboxes / false = radiobuttons
			for(var i=0; i < this.options.length; i++){
				if(this.allowMultiple){
					items.push({
						xtype: 'checkbox',
						boxLabel: this.options[i],
						id: this.id+'-cb-'+i,
						name: 'sel-'+i,
						value: i,
						checked: isSelected(i)
					});
				}else{
					items.push({
						xtype: 'radio',
						boxLabel: this.options[i],
						name: this.name,
						value: i,
						checked: isSelected(i)
					});
				}
			}
		
			Ext.apply(panelCfg,{
				items: items,
				defaults: this.defaults
			});
		
			this.panel = new Ext.Container(panelCfg);
			this.panel.ownerCt = this;
			this.el = this.panel.getEl();
			
			var fields = this.panel.findBy(function(c){
				return c.isFormField;
			}, this);
			
			this.items = new Ext.util.MixedCollection();
			this.items.addAll(fields);
		}
		itasks.tui.ChoiceControl.superclass.onRender.call(this, ct, position);
	},
	
	afterRender : function(){
		itasks.tui.ChoiceControl.superclass.afterRender.call(this);
		
		this.eachItem(function(item){
			item.on('check',this.fireChecked, this);
			item.inGroup = true;
		});
	},
	
	//buffer to prevent radio group buttons firing twice (uncheck of previous -> check of new)
	fireChecked : function() {
		if(!this.checkTask){
			this.checkTask = new Ext.util.DelayedTask(this.bufferChecked, this);
		}
		this.checkTask.delay(10);
	},
	
	bufferChecked : function(){
		var arr = [];
        this.eachItem(function(item){
            if(item.checked){
                arr.push(item);
            }
        });
        this.fireEvent('change', this, arr);
	},
	
	doLayout: function(){
		if(this.rendered){
			this.panel.forceLayout = this.ownerCt.forceLayout;
			this.panel.doLayout();
		}
	},
	
//returns a list of checked indices	
	getValue : function(){	
		var out = [];
		var multiple = this.allowMultiple;
		
		this.eachItem(function(item){
			if(item.checked){
				out.push(item.value);
				if(!multiple) return false;
			}
		});
		
		return out;
	}
});

Ext.reg('itasks.tui.Choice', itasks.tui.ChoiceControl);Ext.ns('itasks.tui.common');

itasks.tui.common.markError = function(field,msg){
	field.msgTarget = 'side';
	
	(function(){
		if(field.rendered && !field.preventMark){
			msg = msg || field.errorText;
			
			var mt = field.getMessageHandler();
			
			if(mt && mt.markError){
				mt.markError(field, msg);
			}else if(field.errorTarget){
				var t = Ext.getDom(field.errorTarget);
				if(t){
					t.innerHTML = msg;
					t.style.display = field.msgDisplay;
				}
			}
		}
	
		field.activeError = msg;
	}).defer(50,this);
};

itasks.tui.common.clearError = function(field){
	if(field.rendered && !field.preventMark){
		var mt = field.getMessageHandler();
		if(mt && mt.clearError){
			mt.clearError(field);
		}else if(field.errorTarget){
			var t = Ext.getDom(field.errorTarget);
			if(t){
				t.innerHTML = '';
				t.style.display = 'none';
			}		
		}
	}
	
	delete field.activeError;
};

itasks.tui.common.markHint = function(field,msg){
	field.msgTarget = 'side';
	
	(function(){
		if(field.rendered && !field.preventMark){
			msg = msg || field.hintText;
			
			var mt = field.getMessageHandler();
			
			if(mt && mt.markHint){
				mt.markHint(field, msg);
			}else if(field.hintTarget){
				var t = Ext.getDom(field.hintTarget);
				if(t){
					t.innerHTML = msg;
					t.style.display = field.msgDisplay;
				}
			}
		}

		field.activeHint = msg;
	}).defer(50,this);
};
	
itasks.tui.common.clearHint = function(field){
	if(field.rendered && !field.preventMark){
		var mt = field.getMessageHandler();
		if(mt && mt.clearHint){
			mt.clearHint(field);
		}else if(field.hintTarget){
			var t = Ext.getDom(field.hintTarget);
			if(t){
				t.innerHTML = '';
				t.style.display = 'none';
			}
		}
	}
	
	delete field.activeHint;
};

itasks.tui.common.alignHintIcon = function(field){	

	if(field.wrap){
		field.hintIcon.alignTo(field.wrap, 'tl-tr', [2, 0]);
	}else{
		field.hintIcon.alignTo(field.el, 'tl-tr', [2, 0]);
	}
};

itasks.tui.common.alignErrIcon = function(field){

	if(field.wrap){
		field.errIcon.alignTo(field.wrap, 'tl-tr', [2, 0]);
	}else{
		field.errIcon.alignTo(field.el, 'tl-tr', [2, 0]);
	}
};

//append the hint functions to the MessageTarget Framework
Ext.apply(Ext.form.MessageTargets.side, {
	markError : function(field, msg){
		if(!field.errIcon){
			var elp = field.getErrorCt();
			
			if(!elp) return;
			
			field.errIcon = elp.createChild({cls: 'x-form-invalid-icon'});
			
			if(field.ownerCt){
				//field.ownerCt.on('afterlayout', function(){ itasks.tui.common.alignErrIcon(this)}, field);
				//field.ownerCt.on('expand', function(){ itasks.tui.common.alignErrIcon(this)}, field);
			}
			field.on('resize', function(){ itasks.tui.common.alignErrIcon(this)}, field);
			field.on('destroy', function(){ Ext.destroy(this.errIcon); },field);
		}
		
		itasks.tui.common.alignErrIcon(field);
		field.errIcon.dom.qtip = msg;
		field.errIcon.dom.qclass = 'x-form-invalid-tip';
		field.errIcon.show();	
	},
	
	clearError : function(field){
		if(field.errIcon && field.errIcon.dom){
			field.errIcon.dom.qtip = '';
			field.errIcon.hide();
		}
	},
	
	markHint : function(field, msg){			
		if(!field.hintIcon){
			var elp = field.getErrorCt();
			
			if(!elp) return;
			
			field.hintIcon = elp.createChild({cls: 'x-form-hint-icon'});
			if(field.ownerCt){
				//field.ownerCt.on('afterlayout', function() {itasks.tui.common.alignHintIcon(this)}, field);
				//field.ownerCt.on('expand', function() {itasks.tui.common.alignHintIcon(this)}, field);
			}
			field.on('resize', function() {itasks.tui.common.alignHintIcon(this)}, field);
			field.on('destroy', function(){ Ext.destroy(this.hintIcon); }, field);
		}
		
		itasks.tui.common.alignHintIcon(field)
		field.hintIcon.dom.qtip = msg;
		field.hintIcon.dom.qclass = 'x-form-hint-tip';
		field.hintIcon.show();		
	},
	
	clearHint: function(field){
		if(field.hintIcon && field.hintIcon.dom){
			field.hintIcon.dom.qtip = '';
			field.hintIcon.hide();
		}
	}	
});
Ext.ns('itasks.tui');

itasks.tui.ListContainer = Ext.extend(Ext.Panel,{

	initComponent: function(){
		
		if(this.fieldLabel == null) delete this.fieldLabel;
		else this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
		
		Ext.apply(this,
		{ autoHeight: true
		, layout: 'anchor'
		, unstyled: true
		, cls: 'list'
		, autoWidth: true
		});	
		
		itasks.tui.ListContainer.superclass.initComponent.apply(this,arguments);
		
		this.on('afterlayout', function(ct,cmp,pos) { 
			if(this.staticDisplay) return;
		
			for(var i=0; i<this.items.length; i++){
				this.items.get(i).toggleLastItem(i == this.items.length-1);
			}
			
			if(this.sbExpanded) this.expandSidebar(); //redo opening of sidebar, so the new toolboxes are shown as well..
		});
	},
	
	afterRender : function(ct,position){
		itasks.tui.ListContainer.superclass.afterRender.call(this,ct,position);
		this.initSidebar();
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	getSidebarEl : function(){		
		if(!this.sidebarEl){
			this.sidebarEl = this.sidebarCt.createChild({cls: 'list-sidebar-bg', id: this.id+'-sidebar-bg', html: ' '});
		}	
		
		return this.sidebarEl;
	},
	
	getExpandedEl : function(){
		if(!this.expandedEl){
			this.expandedEl = this.sidebarCt.createChild({cls: 'list-sidebar-expanded x-layout-split-east', id: this.id+'-expanded', html: ' '});
			var mini = this.expandedEl.createChild({cls: 'x-layout-mini x-layout-mini-east list-sidebar-control', id: this.id+'-expanded-mini', html: ' '});
			
			this.expandedEl.addClassOnOver('x-layout-collapsed-over');
			this.expandedEl.on('click',this.collapseSidebar, this, {stopEvent:true});
			
			this.expandedEl.hide();
		}
		
		return this.expandedEl;
	},
	
	getCollapsedEl : function(){
		if(!this.collapsedEl){
			
			this.collapsedEl = this.sidebarCt.createChild({cls: 'list-sidebar-collapsed x-layout-cmini-east', id: this.id+'-collapsed', html: ' '});	
			var mini = this.collapsedEl.createChild({cls: 'x-layout-mini x-layout-mini-east list-sidebar-control', id: this.id+'-collapsed-mini', html: ' ',});
			
			this.collapsedEl.addClassOnOver('x-layout-collapsed-over');
			this.collapsedEl.on('click', this.expandSidebar, this, {stopEvent: true});	
		}
		
		return this.collapsedEl;
	},
	
	initSidebar : function(){		
		if(this.staticDisplay) return;
		
		this.sidebarCt = this.el.createChild({cls: 'list-sidebar', id: this.id+'-sidebar'});
		this.getCollapsedEl();	
	},
	
	collapseSidebar : function() {
		var ct = this;
		
		var x0 = ct.sidebarCt.getX();
		var sb = ct.getSidebarEl();
		var ce = ct.getCollapsedEl();
		var ee = ct.getExpandedEl();
		
		ee.hide();
		
		for(var i=0; i<ct.items.length; i++){
			var item = ct.items.get(i);
			item.collapseToolbox();
		}

		this.sidebarCt.shift({width: 5, callback: function() { ce.slideIn('r',{ duration: 0.20 }); }});
		this.sbExpanded = false;
	},
	
	expandSidebar : function() {
		var ct = this;
		
		var x0 = ct.sidebarCt.getX();
		var sb = ct.getSidebarEl();
		var ce = ct.getCollapsedEl();
		var ee = ct.getExpandedEl();
		
		ce.hide();
		this.sidebarCt.shift({ width: 85, 
		callback: function() 
			{	ee.show();	
				for(var i=0; i<ct.items.length; i++){					
					var item = ct.items.get(i);
					item.expandToolbox();
				}			
			}
		});	
		
		this.sbExpanded = true;
	},
	
	setError: function(msg){
		if(this.staticDisplay) return;
		
		(function() {
			if(msg == "") this.clearError();
			else this.markError(msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		if(msg == "") this.clearHint();
		else this.markHint(msg);
	},
	
	makeMessageField : function(){
		this.msgField = this.el.insertSibling({tag:'div'},'after');
		this.msgField.createChild({cls: 'x-constructor-panel-tc'});
		this.msgField.createChild({cls: 'list-msg-field'});
	},
	
	markHint : function (msg){
		if(this.rendered){
			if(!this.msgField) {
				this.makeMessageField();
			}else{
				this.msgField.show();
			}
			
			if(!this.hintIcon){
				var ct = this.msgField.child('[class = list-msg-field]');
				this.hintIcon = ct.createChild({cls: 'x-record-hint-icon'});
				this.hintIcon.setVisibilityMode(Ext.Element.DISPLAY);
			}
			
			this.hintIcon.dom.innerHTML = msg;
			this.hintIcon.setVisible(true);
		}
	},
	
	markError: function(msg){
		if(this.rendered){
			if(!this.msgField) {
				this.makeMessageField();
			}else{
				this.msgField.show();
			}
			
			if(this.hintIcon) this.hintIcon.hide();
			
			if(!this.errorIcon){
				var ct = this.msgField.child('[class = list-msg-field]');
				this.errorIcon = ct.createChild({cls: 'x-record-invalid-icon'});
				this.errorIcon.setVisibilityMode(Ext.Element.DISPLAY);
			}
			
			this.errorIcon.dom.innerHTML = msg;
			this.errorIcon.setVisible(true);
		}
	},
	
	clearHint : function(){
		if(this.hintIcon){
			this.hintIcon.setVisible(false);
			this.msgField.hide();
		}
	},
	
	clearError : function(){
		if(this.errorIcon){
			this.errorIcon.setVisible(false);
			this.msgField.hide();
		}
	}
});

Ext.ns('itasks.tui.list');

var T = itasks.tui.list;

T.ListItemControl = Ext.extend(Ext.Panel,{

	initComponent : function(){	
		Ext.apply(this,
		{ unstyled: true
		, autoHeight: true
		, autoWidth: true
		//, layout: 'form'
		, cls: ((this.index%2) == 0)?"list-item-light":"list-item-dark"
		});
			
		T.ListItemControl.superclass.initComponent.apply(this,arguments);
	},
	
	expandToolbox : function(){
		if(this.isLast || this.isExpanded) return;
		
		if(!this.toolbox){
			this.toolbox = this.el.createChild({ cls: 'list-toolbox' });
			
			this.upBtn = this.toolbox.createChild({ cls: 'list-toolbox-button list-button-up' });
			this.dnBtn = this.toolbox.createChild({ cls: 'list-toolbox-button list-button-down', style: 'margin-right: 4px' });
			this.addBtn = this.toolbox.createChild({ cls: 'list-toolbox-button list-button-add' });
			this.remBtn = this.toolbox.createChild({ cls: 'list-toolbox-button list-button-rem' });
			
			this.upBtn.on('click',this.handleClick.createDelegate(this,['mup',this.name,this.index]));
			this.dnBtn.on('click',this.handleClick.createDelegate(this,['mdn',this.name,this.index]));
			this.addBtn.on('click',this.handleClick.createDelegate(this,['add',this.name,this.index]));
			this.remBtn.on('click',this.handleClick.createDelegate(this,['rem',this.name,this.index]));
		}
			
		this.toolbox.fadeIn({ duration: 0.25 });	
		this.isExpanded = true;
	},
	
	collapseToolbox : function(){
		if(this.isLast || !this.toolbox || !this.isExpanded) return;
		
		this.toolbox.fadeOut({ duration: 0.25 });
		this.isExpanded = false;	
	},
	
	handleClick: function(action,name,index){
		var formCt = this.findParentByType(itasks.ttc.FormContainer);
		formCt.addUpdate(name,action+"_"+index);
		formCt.sendUpdates(false);	
	},
	
	toggleLastItem : function(isLast){
		if(isLast){
			this.addClass('list-last-item');
			this.isLast = true;
		}else{
			this.removeClass('list-last-item');
			this.isLast = false;
		}
	}
});

Ext.reg('itasks.tui.List', itasks.tui.ListContainer);
Ext.reg('itasks.tui.list.Item', itasks.tui.list.ListItemControl);Ext.ns('itasks.tui');

itasks.tui.RecordContainer = Ext.extend(Ext.form.FieldSet,{

	initComponent : function(){
		
		this.autoHeight = true;
		this.boxMinWidth = 500;
		this.autoWidth = true;
		
		if(this.title == null) delete this.title
		else this.title = itasks.util.fieldLabel(this.optional,this.title);
		
		delete this.fieldLabel;
		
		this.checkboxName  = this.name+'-cb';
		this.checkboxToggle = this.optional;
		
		itasks.tui.RecordContainer.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.tui.RecordContainer.superclass.afterRender.call(this,arguments);
		
		if(this.optional){
			this[this.hasValue?'expand':'collapse']();
			this.checkbox.dom.checked = this.hasValue;
		}
		
		(function(){
			this.setError(this.errorMsg);
			this.setHint(this.hintMsg);
		}).defer(50,this);
	},
	
	onCheckClick : function() {
		this[this.checkbox.dom.checked?'expand':'collapse']();
	
		var formCt = this.findParentByType(itasks.ttc.FormContainer);
		formCt.addUpdate(this.name,(this.checkbox.dom.checked)?'create':'');
		formCt.sendUpdates(false);	
	},
	
	setError: function(msg){		
		if(this.staticDisplay) return;
		
		(function() {
			if(msg == "") this.clearError();
			else this.markError(msg);
		}).defer(50,this);
	},
	
	setHint: function(msg){
		if(this.staticDisplay) return;
		
		(function() {
			if(msg == "") this.clearHint();
			else this.markHint(msg);
		}).defer(50,this);
	},
	
	markHint : function (msg){
		if(this.errorIcon && this.errorIcon.isVisible()) return;
	
		if(this.rendered){
			if(!this.hintIcon){
				this.hintIcon = this.el.insertFirst({cls: 'x-record-hint-icon'});	
				this.hintIcon.setVisibilityMode(Ext.Element.DISPLAY);
			}

			this.hintIcon.dom.innerHTML = msg;
			this.hintIcon.setVisible(true);					
		}
	},
	
	markError : function(msg){
		if(this.rendered){
			if(this.hintIcon){
				this.hintIcon.hide();
			}
			
			if(!this.errorIcon){
				this.errorIcon = this.el.insertFirst({cls: 'x-record-invalid-icon'});
				this.errorIcon.setVisibilityMode(Ext.Element.DISPLAY);
			}
			
			this.errorIcon.dom.innerHTML = msg;
			this.errorIcon.setVisible(true);
		}
	},
	
	clearHint : function(){
		if(this.hintIcon) this.hintIcon.setVisible(false);
	},
	
	clearError: function(){
		if(this.errorIcon) this.errorIcon.setVisible(false);
	}
});

Ext.reg('itasks.tui.Record',itasks.tui.RecordContainer);Ext.ns('itasks.tui');

itasks.tui.TupleContainer = Ext.extend(Ext.Container,{

	initComponent: function(){
		
		this.unstyled = true;
		this.autoHeight = true;
		
		this.layout = 'form'
				
		if(this.fieldLabel == null) delete this.fieldLabel;
		else this.fieldLabel = itasks.util.fieldLabel(this.optional,this.fieldLabel);
			
		itasks.tui.TupleContainer.superclass.initComponent.apply(this,arguments);
	},

	afterRender: function(){
		itasks.tui.TupleContainer.superclass.afterRender.call(this,arguments);
		
		/*for(var i=0; i < this.items.length; i++){
			var itm = this.items.get(i);
			itm.addClass('tuple-item');
		}*/
	},
	getPreferredWidth : function(){
		var w = 0;
		
		for(var i=0; i < this.items.length; i++){
			var itm = this.items.get(i);
			if(itm.getPreferredWidth) w += itm.getPreferredWith();
		}
		
		return (w>700)?700:w
	},
	
	setPreferredWidth : function(width){
		this.setWidth(width);
		
		for(var i=0; i < this.items.length; i++){
			var itm = this.items.get(i);
			if(itm.getWidth() > this.getWidth()) this.setAutoScroll(true);
		}
	}
});

Ext.reg('itasks.tui.Tuple',itasks.tui.TupleContainer);Ext.ns('itasks.tui');

itasks.tui.AppletContainer = Ext.extend(Ext.Panel,{
	
	initCompent : function(){
	
	
		itasks.tui.AppletContainer.superclass.initComponent.apply(this,arguments);
		
		this.bubble(function(ct){ if(this.xtype == 'itasks.ttc.form') this.fullscreen = true });
	}
});

Ext.reg('itasks.tui.Applet', itasks.tui.AppletContainer);Ext.ns('itasks.ttc.common');

itasks.ttc.common.attachTaskHandlers = function(comp,taskId){

	// Scary hack! Don't look below!
	new Ext.util.DelayedTask().delay(100,itasks.ttc.common.attachDocumentLinkInformation,comp);
	// End of scary hack
		
	var changeTaskEvent = function () {
			
		var ct = this.findParentByType(itasks.ttc.FormContainer);
		if (!ct)
			ct = this.findParentByType(itasks.ttc.InstructionContainer);
		if(!ct)
			ct = this.findParentByType(itasks.ttc.MessageContainer);
		if (!ct)
			// if element is not inside form/instr/message it's a group's toolbar
			ct = this.findParentByType(itasks.ttc.GroupContainer);
		if(!ct) return;
		
		//Helper function to get the value of a checkbox group
		function checkboxValues(boxes) {
			var values = [];
			var num = boxes.length;
			for(var i = 0; i < num; i++) {
				values[values.length] = boxes[i].value;
			}
			return Ext.encode(values);
		}
		
		var value;
		switch(this.xtype) {
			case "itasks.tui.Date": value = this.getRawValue(); break;
			case "radiogroup": value = this.getValue().value; break;
			case "checkboxgroup": value = checkboxValues(arguments[1]); break;
			default: value = this.getValue();
		}
		ct.addUpdate(this.name, value);
		ct.sendUpdates(true);
	};
	var clickTaskEvent = function () {
		
		if(this.clickCB) this.clickCB(this);
		
		var ct = this.findParentByType(itasks.ttc.FormContainer);
		if (!ct)
			ct = this.findParentByType(itasks.ttc.InstructionContainer);
		if(!ct)
			ct = this.findParentByType(itasks.ttc.MessageContainer);
		// if element is not inside form/instr/message it's a group's toolbar
		if (!ct)
			ct = this.findParentByType(itasks.ttc.GroupContainer);
		if(!ct) return;
			
		var taskId = (comp.taskId)? comp.taskId : ct.taskId
			
		ct.addUpdate(this.name, this.value);
		ct.sendUpdates();
	};	
	var choiceTaskEvent  = function(){
		var ct = this.findParentByType(itasks.ttc.FormContainer);
		if (!ct)
			ct = this.findParentByType(itasks.ttc.InstructionContainer);
		if(!ct)
			ct = this.findParentByType(itasks.ttc.MessageContainer);
		// if element is not inside form/instr/message it's a group's toolbar
		if (!ct)
			ct = this.findParentByType(itasks.ttc.GroupContainer);
		if(!ct) return;
		
		
		ct.addUpdate(this.name, Ext.encode(comp.getValue()));
		ct.sendUpdates(true);
	}
	
	switch(comp.getXType()) {
			case "textfield":
			case "itasks.tui.String":
			case "itasks.tui.Char":
			case "itasks.tui.Int":
			case "itasks.tui.Real":
			case "itasks.tui.Note":
			case "itasks.tui.Date":
			case "itasks.tui.Time":
			case "itasks.tui.Username":
			case "itasks.tui.Currency":
			case "itasks.tui.Password":
			case "textarea":
			case "numberfield":
			case "datefield":
			case "timefield":
			case "radiogroup":
				comp.on("change",changeTaskEvent);
				break;
			case "checkbox":
			case "itasks.tui.Bool":
				comp.on("check",changeTaskEvent);
				break;
			case "checkboxgroup":
				comp.on("change",changeTaskEvent);
				break;
			case "combo":
			case "itasks.userfield":
			case "itasks.tui.ColorChooser":
				comp.on("select",changeTaskEvent);
				break;
			case "button":
			case "itasks.tui.FormButton":
			case "menuitem":
				if(comp.name)
					comp.on("click",clickTaskEvent);
				break;
			case "itasks.tui.FormattedText":
			case "itasks.tui.SourceCode":
				comp.on("update",changeTaskEvent);
				break;
			case "itasks.tui.Choice":
				comp.on("change",choiceTaskEvent);
				break;
	}
	if(comp.buttons) {
		var num = comp.buttons.length;
		for(var i = 0; i < num; i++) {
			comp.buttons[i].on("click",clickTaskEvent);
		}
	}
	//attach recursively
	if(comp.items && comp.items.each)
		comp.items.each(itasks.ttc.common.attachTaskHandlers, comp, taskId);
	if(comp.menu)
		itasks.ttc.common.attachTaskHandlers(comp.menu,taskId);
	if(comp.topToolbar)
		itasks.ttc.common.attachTaskHandlers(comp.topToolbar,taskId);
};

itasks.ttc.common.attachDocumentLinkInformation = function() {
	
	var links   = Ext.query("a[name=x-form-document-link]");
	var plinks = Ext.query("a[name=x-form-document-preview-link]");
	
	for(var x=0; x < links.length; x++){
		var link = links[x];
		
		link.href = Ext.urlAppend(link.href,'session='+itasks.app.session);
		link.name = "";
		
		for(var y=0; y < plinks.length; y++){				
			if(plinks[y].id == link.id){
				var plink = plinks[y];		

				plink.href="javascript:itasks.util.preview('"+link.href.replace( 'download','preview')+"')";
				plink.name = "";
			}
		}
	}
};

itasks.ttc.common.SubjectPanel = Ext.extend(Ext.Panel,{
	initComponent : function(){
		
		Ext.apply(this,{
			unstyled: true
		});
		
		if(Ext.isDefined(this.headerButton)) {
			this.items = [{html: this.subject, unstyled: true, columnWidth: 1}, this.headerButton];
			this.layout = 'column';
		} else {
			this.items = [{html: this.subject, unstyled: true}];
		}

		itasks.ttc.common.SubjectPanel.superclass.initComponent.apply(this,arguments);
	}
});

itasks.ttc.common.setFullscreen = function(ct){
	ct.fullscreen = true;
};

itasks.ttc.common.setupHotkeys = function(tb, parent) {
	// collect all hotkeys
	var hotkeys = new Ext.util.MixedCollection();
	
	var collectHotkeys = function(item) {
		var hk = item.hotkey;
		if(hk) {
			hotkeys.add({hotkey: hk, menuitem: item});
			// append hotkey-string to item name
			var str = hk.key;
			if (hk.shift)	str = "Shift+" + str;
			if (hk.alt)		str = "Alt+" + str;
			if (hk.ctrl)	str = "Ctrl+" + str;
			item.setText(item.text + "&nbsp;&nbsp;&nbsp;&nbsp;(" + str + ")");
		} else if (item.items || item.menu) {
			var children =  item.items || item.menu.items;
			for(var i = 0; i < children.length; i++) {
				collectHotkeys(children.get(i));
			}
		}
	}
	
	collectHotkeys(tb);
	
	// disabled old hotkeys
	if (parent.keyMap)
		parent.keyMap.disable();

	if (hotkeys.getCount() == 0)
		return;
	
	// build up config array for KeyMap
	var conf = new Array();
	hotkeys.each(function(hk) {
		var h = hk.hotkey;
		conf[conf.length] = {
			key: h.key,
			ctrl: h.ctrl,
			alt: h.alt,
			shift: h.shift,
			stopEvent: true,
			handler: function() {
				var item = hk.menuitem;
				// only fire hotkey-event if item is not disabled
				if (!item.disabled) {
					parent.addUpdate(item.name, item.value);
					parent.sendUpdates();
				}
			}
		};
	});

	parent.keyMap = new Ext.KeyMap(parent.getEl(), conf);
};

Ext.reg('itasks.ttc.common.subject', itasks.ttc.common.SubjectPanel);Ext.ns('itasks.ttc');

itasks.ttc.InteractionBase = Ext.extend(Ext.Panel, {

	initComponent : function() {
		this.buildComponents(this);
		this.tbar = this.content.tbar;
		delete this.content;
		
		Ext.apply(this,
		{ layout: 'anchor'
		, taskUpdates : {}
		, url: itasks.config.serverUrl + '/work/tab'
		, items: [this.subjectpanel,this.descriptionpanel,this.panel]
		, unstyled: true
		, autoScroll: true
		});
		
		itasks.ttc.InteractionBase.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.ttc.InteractionBase.superclass.afterRender.call(this,arguments);
		//attachTaskHandlers is moved to file 'TTCCommon.js'		
		itasks.ttc.common.attachTaskHandlers(this);
		
		this.setupToolbar();
	},
	
	addUpdate: function(name, value) {
		this.taskUpdates[name] = value;
	},
	
	sendUpdates: function(delay) {
		if(delay) {
			new Ext.util.DelayedTask().delay(250,this.sendUpdates,this);
		} else {
			var wt = this.findParentByType(itasks.WorkPanel) || this.workPanel;
			if(!wt) return;
			
			wt.sendTaskUpdates(this.taskId,this.taskUpdates);
		
			this.taskUpdates = {};
		}
	},
	
	setupToolbar: function() {
		var tb = this.getTopToolbar();
		
		tb.setVisible(tb.items.length > 0);
		
		var enabledPresent = false;
		for(var i = 0; i < tb.items.length; i++) {
			if(!tb.get(i).disabled) {
				enabledPresent = true;
				break;
			}
		}
		
		var cls = 'ToolbarNoEnabledItems';
		if(enabledPresent)
			tb.removeClass(cls);
		else {
			tb.removeClass(cls);
			tb.addClass(cls);
		}
		
		var checkGroupOnly = function(item) {
			if(item.disabled)
				return true;
				
			if(Ext.isBoolean(item.topGroupAction)) {
				return item.topGroupAction;
			} else if (item.getXType() != 'menuseparator') {
				var children =  item.items || item.menu.items;
				for(var i = 0; i < children.length; i++) {
					if (!checkGroupOnly(children.get(i)))
						return false;
				}
			}
			return true;
		};
		
		var cls = 'ToolbarGroupActionsOnly';
		if(checkGroupOnly(tb)) {
			tb.removeClass(cls);
			tb.addClass(cls);
		} else {
			tb.removeClass(cls);
		}
		
		itasks.ttc.common.setupHotkeys(tb, this);
	}
});Ext.ns('itasks.ttc');

itasks.ttc.FormContainer = Ext.extend(itasks.ttc.InteractionBase, {

	initComponent : function() {
		this.cls = 'FormContainer';	
		itasks.ttc.FormContainer.superclass.initComponent.apply(this,arguments);
	},
	
	buildComponents: function(data){
	
		this.panel = new itasks.ttc.form.FormPanel({
			xtype: 'itasks.ttc.form.panel',
			items: data.content.form,
			buttons: data.content.buttons,
			width: 720
		});
		this.subjectpanel = {
			xtype: 'itasks.ttc.common.subject',
			cls: 'TTCSubject',
			subject: data.subject,
			headerButton: this.headerButton,
			width: 720
		};
		this.descriptionpanel = {
			xtype: 'panel',
			cls: 'TTCDescription',
			unstyled: true,
			html: data.description,
			width: 720
		};
	},
	
	update: function(data) {
		if(data.updates) {
			//clear the form from any hints and errors
			this.clearErrorsNHints();	
		
			var num = data.updates.length;
			for (i = 0; i < num; i++) {
				var update = data.updates[i];
				switch(update[0]) {
					case "TUIAdd":
						this.addComponent(update[1],update[2]);
						break;
					case "TUIAddTo":
						this.addComponentTo(update[1],update[2]);
						break;					
					case "TUIRemove":
						this.removeComponent(update[1]);
						break;
					case "TUIReplace":
						this.replaceComponent(update[1],update[2]);						
						break;
					case "TUISetEnabled":
						this.enableComponent(update[1],update[2]);
						break;
					case "TUISetValue":
						this.setComponentValue(update[1],update[2]);
						break;
					case "TUIReplaceMenu":
						this.replaceToolbar(update[1]);
						break;
					case "TUISetError":
						var ct = Ext.getCmp(update[1]);
						if(ct && ct.setError) ct.setError(update[2]);					
					break;
					case "TUISetHint":
						var ct = Ext.getCmp(update[1]);
						if(ct && ct.setHint) ct.setHint(update[2]);
					break;
				}
			}				
		} else {
		
			//Completely replace form
			this.taskId = data.taskId;
			this.removeAll();
			this.buildComponents(data);
			
		
			this.add(this.subjectpanel);
			this.add(this.descriptionpanel);
			this.add(this.panel);
			
			this.doLayout();
			
			this.replaceToolbar(data.content.tbar);
			itasks.ttc.common.attachTaskHandlers(this);
		}
		
		//this.setupHotkeys(data.hotkeys);
	},
		
	addComponent :  function (id, cmp){
		var ct = Ext.getCmp(id);
		var find = function(cmt,cnt,ind) {
			if(cnt.items.get(ind) == undefined)
				return ind;
			if(cnt.items.get(ind) == cmt)
				return ind;
			else
				return find(cmt,cnt,ind + 1);
		}
		
		if(!ct) return;

		var index = find(ct, ct.ownerCt, 0) + 1;
		var newct = ct.ownerCt.insert(index, cmp);
		
		//ct.ownerCt.doLayout();
		//ct.ownerCt.syncSize();
		ct.ownerCt.ownerCt.doLayout();
		
		itasks.ttc.common.attachTaskHandlers(newct);
	},
	
	addComponentTo : function(parent, cmp){
		var ct = Ext.getCmp(parent);
		if(!ct) return;
		
		ct.add(cmp);
		ct.doLayout();
		
		itasks.ttc.common.attachTaskHandlers(ct);		
	},
	
	removeComponent: function(id){
		var ct = Ext.getCmp(id);
		if(!ct) return;
		
		var oct = ct.ownerCt;
		
		oct.remove(ct);
		oct.doLayout();
	},
	
	replaceComponent : function(id, cmp){	
		var ct = Ext.getCmp(id);
		if(!ct) return;
		
		var find = function(cmt,cnt,ind) {
			if(cnt.items.get(ind) == undefined)
				return ind;
			if(cnt.items.get(ind) == cmt)
				return ind;
			else
				return find(cmt,cnt,ind + 1);
		}
		
		var oct = ct.ownerCt;
		
		//Find the index of the reference component
		var index = find(ct, ct.ownerCt, 0);
		
		oct.remove(index);
		//oct.doLayout();
		
		var newct = oct.insert(index, cmp);
		
		var f = function(){ this.doLayout(); itasks.ttc.common.attachTaskHandlers(this); };
		f.defer(50,oct);
	},
	
	enableComponent : function(id,enabled){
		var ct = Ext.getCmp(id);
		if(ct && ct.setDisabled) {
			ct.setDisabled(!enabled);
		}
	},
	
	setComponentValue : function(id,value){
		var ct = Ext.getCmp(id);
		
		if(!ct || !ct.setValue) return;
		//suspend events to prevent check-event for checkbox
		ct.suspendEvents();
		if (ct.xtype == "radio") {
			if(value == "true") {
				//first unset current element...
				var group = ct.findParentByType("radiogroup");
				var cur = group.getValue();
				if(cur.setValue)
					cur.setValue(false);
				//...then set new one
				ct.setValue(true);
			}			
		}else {
			ct.setValue(value);
		}
		ct.resumeEvents();					
	},
		
	replaceToolbar: function(newTb) {
		var tb = this.getTopToolbar();
		tb.removeAll();
		if(newTb)
			tb.add(newTb);
		this.setupToolbar(tb);
	},
	
	clearErrorsNHints : function(){		
		var f = function(ct){
			if(!ct) return true;
			
			if(ct.setHint) ct.setHint(''); //empty string == clear
			if(ct.setError) ct.setError('');
			
			return true;
		}
		
		this.panel.cascade(f);
	}
});

Ext.ns('itasks.ttc.form');

itasks.ttc.form.FormPanel = Ext.extend(Ext.Panel, {

	initComponent : function(){
	
		Ext.apply(this,
		{ unstyled: true
		, cls: 'FormPanel'
		, width: 720
		, layout: 'form'
		, autoScroll: true
		});
		
		itasks.ttc.form.FormPanel.superclass.initComponent.apply(this,arguments);
	}
});

Ext.reg('itasks.ttc.form',itasks.ttc.FormContainer);
Ext.reg('itasks.ttc.form.panel', itasks.ttc.form.FormPanel);Ext.ns('itasks.ttc');

itasks.ttc.FinishedContainer = Ext.extend(Ext.Panel,{
	initComponent: function() {
		Ext.apply(this,
		{ unstyled: true
		, cls: 'FinishedContainer'
		, width: 720
		, html: '<div class="FinishedContainer-Text">'+this.msg+'</div>'
		});
		
		itasks.ttc.ResultContainer.superclass.initComponent.apply(this,arguments);
	}
});

Ext.reg('itasks.ttc.finished',itasks.ttc.FinishedContainer);Ext.ns('itasks.ttc');

itasks.ttc.MessageContainer = Ext.extend(itasks.ttc.InteractionBase, {

	initComponent : function() {
		this.cls = 'MessageContainer';
		
		itasks.ttc.MessageContainer.superclass.initComponent.apply(this,arguments);
	},
	
	buildComponents: function(data){
		this.panel = {
			xtype: 'itasks.ttc.message.panel',
			items: data.content.form,
			buttons: data.content.buttons
		};
		
		this.subjectpanel = {
			xtype: 'itasks.ttc.common.subject',
			cls: 'TTCSubject',
			subject: data.subject,
			headerButton: this.headerButton,
			width: 720
		};
		this.descriptionpanel = {
			xtype: 'panel',
			cls: 'TTCDescription',
			html: data.description,
			unstyled: true,
			width: 720
		};
	},
	
	update: function(data){
		//this.setupHotkeys(data.hotkeys);
	}
});

Ext.ns('itasks.ttc.message');

itasks.ttc.message.MessagePanel = Ext.extend(Ext.Panel, {

	initComponent : function(){
		Ext.apply(this,
		{ layout: 'fit'
		, unstyled: true
		, cls: 'MessagePanel'
		, width: 720
		});
		
		itasks.ttc.message.MessagePanel.superclass.initComponent.apply(this,arguments);
	}

});

Ext.reg('itasks.ttc.message',itasks.ttc.MessageContainer);
Ext.reg('itasks.ttc.message.panel', itasks.ttc.message.MessagePanel);Ext.ns('itasks.ttc');

itasks.ttc.MonitorContainer = Ext.extend(Ext.Panel,{
	initComponent: function() {
		Ext.apply(this,{
			defaults: {
				unstyled: true
			},
			unstyled: true,
			cls: 'MonitorContainer',
			items: [
				{ xtype: 'itasks.ttc.common.subject'
				, cls: 'TTCSubject'
				, subject: this.subject
				, headerButton: this.headerButton
				, width: 720
				},
				{ xtype: 'panel'
				, cls: 'TTCDescription'
				, html: this.description
				, width: 720
				},
				{ xtype: 'panel'
				, cls: 'MonitorPanel'
				, unstyled: true
				, html: this.html
				, width: 720
				}
			]
		});
		delete this.html;
		
		itasks.ttc.MonitorContainer.superclass.initComponent.apply(this,arguments);
	},
	
	update: function(data){		
		if(this.get(1).rendered){
			this.get(1).el.update(data.html);
		}else{
			this.get(1).html = data.html;
		}
	}
});

Ext.reg('itasks.ttc.monitor',itasks.ttc.MonitorContainer);Ext.ns('itasks.ttc');

itasks.ttc.InstructionContainer = Ext.extend(Ext.Panel,{
	initComponent: function() {
		
		Ext.apply(this,
		{ cls: 'InstructionContainer'
		, unstyled: true
		, taskUpdates : {}
		, items: [
			{ xtype: 'itasks.ttc.common.subject'
			, cls: 'TTCSubject'
			, subject: this.subject
			, headerButton: this.headerButton
			, width: 720
			},
			{ xtype: 'panel'
			, unstyled: true
			, html: this.description
			, cls: 'TTCDescription'
			, width: 720
			}
		]});
		if(this.context != null){
			this.items[2] = {
				xtype: 'panel',
				html: this.context,
				unstyled: true,
				cls: 'InstructionContainer-Context',
				width: 720
			};
		}
		Ext.apply(this.items[this.items.length - 1],{
			buttons: [{ xtype: 'button'
				, name: 'action'
				, id: 'tf-'+this.taskId+'-action-0'
				, text: 'Done'
				, value: 1
				, disabled: false
				, iconCls: 'icon-ok'
				}]
		});
		
		itasks.ttc.InstructionContainer.superclass.initComponent.apply(this,arguments);
	},
	
	afterRender: function(){
		itasks.ttc.InstructionContainer.superclass.afterRender.call(this,arguments);
		//attachTaskHandlers is moved to file 'TTCCommon.js'		
		itasks.ttc.common.attachTaskHandlers(this);
	},
	
	addUpdate: function(name, value) {
		this.taskUpdates[name] = value;
	},
	
	sendUpdates: function(delay) {
		if(delay) {
			new Ext.util.DelayedTask().delay(250,this.sendUpdates,this);
		} else {
			var wt = this.findParentByType(itasks.WorkPanel);
			if(!wt) return;
			
			wt.sendTaskUpdates(this.taskId,this.taskUpdates);
		
			this.taskUpdates = {};
		}
	},
		
	update: function(data){}
});

Ext.reg('itasks.ttc.instruction',itasks.ttc.InstructionContainer);Ext.ns('itasks.ttc');

itasks.ttc.ResultContainer = Ext.extend(Ext.Panel,{
	initComponent: function() {
		Ext.apply(this,
		{ unstyled: true
		, cls: 'ResultContainer'
		, width: 720
		, html: '<div class="TTCDescription">'+this.subject+'</div><div class="ResultContainer-Text">'+this.result+'</div>'
		});
		
		itasks.ttc.ResultContainer.superclass.initComponent.apply(this,arguments);
	},
	
	update: function(data){
		if(this.rendered){
			this.body.html = '<div class="TTCDescription">'+data.subject+'</div><div class="ResultContainer-Text">'+data.result+'</div>'
		}else{
			this.html = '<div class="TTCDescription">'+data.subject+'</div><div class="ResultContainer-Text">'+data.result+'</div>'
		}
	}
});

Ext.reg('itasks.ttc.result',itasks.ttc.ResultContainer);Ext.ns('itasks.ttc');

itasks.ttc.ProcessControlContainer = Ext.extend(Ext.Panel,{
	initComponent: function(){
		
		Ext.apply(this,
		{ unstyled: true
		, cls: 'ProcessControlContainer'
		, subject: 'Control process properties'
		, items: [
			{ xtype: 'itasks.ttc.common.subject'
			, cls: 'ProcessControlDescription'
			, subject: 'Control process properties'
			, headerButton: this.headerButton
			, width: 720
			},
			{ xtype: 'panel'
			, unstyled: true
			, layout: "form"
			, defaultType: "staticfield"
			, cls: 'ProcessControlPanel'
			, width: 720
			, items: [
				{ html: "Waiting for <i>" +  this.properties.managerProperties.subject + "</i>"
				, style: "margin: 0px 0px 20px 0px;"
				, unstyled: true			
				, xtype: 'panel'
				},{
					xtype: "panel",
					layout: "form",
					defaultType: "staticfield",
					unstyled: true,
					items: [{
						xtype: "itasks.tui.Username",
						preventMark: true,
						fieldLabel: "Assigned to",
						value: itasks.util.formatUser(this.properties.managerProperties.worker),
						listeners: {
							"change" : { fn: 
								function(fld,nv,ov) {
									var ct = this.findParentByType(itasks.WorkPanel);
									var url = itasks.config.serviceUrl+'/json/tasks/'+this.properties.systemProperties.taskId+ '/managerProperties/worker';
									
									var cb = function(response,success){
										if(!response.success || !success) {
											Ext.Msg.alert("Error","An error has occurred: "+response.error);
										}else{
											ct.fireEvent("propertyChanged");
										}
									}									
									
									ct.remoteCall(url,{update: Ext.encode(nv)},cb);
								},
								scope: this 
							}
						}
					},{
						xtype: "itasks.priority",
						fieldLabel: "Priority",
						value: this.properties.managerProperties.priority, 
						listeners: {
							"change" : { fn: 
								function(fld,nv,ov) {
									var ct = this.findParentByType(itasks.WorkPanel);
									var url = itasks.config.serviceUrl+'/json/tasks/'+this.properties.systemProperties.taskId+ '/managerProperties/priority';
									var upd = Ext.encode(nv);
									
									var cb = function(response,success){
										if(!response.success || !success) {
											Ext.Msg.alert("Error","An error has occurred: "+response.error);
										}else{
											ct.fireEvent("propertyChanged");
										}
									}									
									
									ct.remoteCall(url,{update: upd},cb);
								},
								scope: this 
							}
						}
					},{
						fieldLabel: "Progress",
						format: itasks.util.formatProgress,
						value: this.properties.workerProperties.progress
					},{
						fieldLabel: "Issued at",
						format: itasks.util.formatDate,
						value: this.properties.systemProperties.issuedAt
					},{
						fieldLabel: "First worked on",
						format: itasks.util.formatStartDate,
						value: this.properties.systemProperties.firstEvent
					},{
						fieldLabel: "Last worked on",
						format: itasks.util.formatStartDate,
						value: this.properties.systemProperties.latestEvent
					}
				]}
			]}
		]});
		
		itasks.ttc.ProcessControlContainer.superclass.initComponent.apply(this,arguments);	
	},
	
	update: function (data) {
		this.properties = data.properties;

		var p = data.properties;
		var props = [p.managerProperties.worker,p.managerProperties.priority,p.workerProperties.progress,p.systemProperties.issuedAt,p.systemProperties.firstEvent,p.systemProperties.latestEvent];
				
		if(this.getComponent(1).getComponent(0).body) this.getComponent(1).getComponent(0).body.update("Waiting for <i>" + Ext.util.Format.htmlEncode(p.managerProperties.subject) + "</i>");
		this.getComponent(1).getComponent(1).items.each(function(cmt,i){ cmt.setValue(props[i]); });
	}
});

Ext.ns('itasks.ttc.process');

itasks.form.PriorityField = Ext.extend(Ext.form.ComboBox,{
	store: [["HighPriority","High"],["NormalPriority","Normal"],["LowPriority","Low"]],
	triggerAction: 'all',
	editable: false,
	forceSelection: true,
	format: itasks.util.formPriority
});

itasks.form.ProgressField = Ext.extend(itasks.form.InlineField, {
	format: itasks.util.formatProgress,
	field: {
		xtype: "combo",
		value: this.value,
		store: [["TPActive","Active"],["TPStuck","Stuck"],["TPWaiting","Waiting"],["TPReject","Reject"]],
		editable: false,
		triggerAction: "all",
		forceSelection: true
	}
});

Ext.reg("itasks.priority",itasks.form.PriorityField);
Ext.reg("itasks.progress",itasks.form.ProgressField);
Ext.reg('itasks.ttc.proc-control',itasks.ttc.ProcessControlContainer);Ext.ns('itasks.ttc');

itasks.ttc.ParallelContainer = Ext.extend(Ext.Panel, {
	
	control: null,	
	taskId: null,
	id: null,
		
	initComponent : function(){
		
		this.initGrid();
		
		Ext.apply(this,
		{ unstyled: true 
		, autoScroll: true
		, cls: 'ParallelControlContainer'
		, width: 720
		, items: [
			{ cls: 'TTCSubject'
			, unstyled: true
			, html: this.subject
			},
			{ cls: 'TTCDescription'
			, unstyled: true
			, html: this.description
			},
			this.grid
		]		
		});
		
		if (Ext.isDefined(this.headerButton))
			this.tbar = [this.headerButton];
		
		itasks.ttc.ParallelContainer.superclass.initComponent.apply(this,arguments);	
		this.update(this);
	},
	
	initGrid : function() {
		
		this.cellActions = new Ext.ux.grid.CellActions({
			callbacks: {
				'icon-edit' : function(grid, record, action, value){
					var win = new itasks.ttc.parallel.AssignWindow({initUser : value, taskId: record.data.taskId});
					win.show();
				}
			},
			align: 'right'
		});
		
		var store = new Ext.data.JsonStore({
			autoDestroy : true,
			root: 'subtasks',
			fields: [
				{name: 'finished', type: 'bool'},
				'taskId',
				'subject',
				'delegatedTo',
				'progress',
				'description'
			]
		});
		
		var col = new Ext.grid.ColumnModel({
			defaults: {
				menuDisabled: true,
				sortable: true,
				resizable: false
			},
			columns: [
				{header: 'Status', dataIndex: 'finished', renderer: this.renderFinished, width: 50},
				{header: 'Subject',	dataIndex: 'subject', width: 450},
				{header: 'Assigned to', dataIndex: 'delegatedTo', renderer: this.renderDelegated, cellActions:[{ iconCls: 'icon-edit', qtip: 'Re-asign the task to another user'}]}			
			]
		});
		
		this.grid = new Ext.grid.EditorGridPanel({
			cls: 'ParallelControlPanel',
			border: false,
			store : store,
			colModel: col,	
			width: 700,
			height: 250,
			plugins:[this.cellActions],
			autoExpandColumn: 2,
			clicksToEdit: 'auto'
		});
		
		this.grid.on('afteredit', this.handleChange, this);
		this.grid.on('rowdblclick', this.handleDblClick, this);
	},
	
	handleChange : function(edit){
		this.grid.store.commitChanges();
	},
	
	handleDblClick : function(grid,row,e){
		var rec = grid.getStore().getAt(row);
		var taskId = rec.data.taskId+'.0'; //add one shift as the result node is stored as a child of the process node
		var finished = rec.data.finished;
		
		if(finished){
			var worktabs = grid.findParentByType(itasks.WorkTabsPanel);
			var tab = worktabs.openResultTab(taskId);
		}
	},
	
	update : function(data){
		var store = this.grid.store;
		store.loadData({subtasks : data.subtaskInfo},false);
	},
	
	renderFinished: function(val,metadata,rec,row,col,store){
		if(val == false){
			return '<div style="text-align: center"><img src="skins/default/img/icons/hourglass.png" /></div>'
		}else{
			return '<div style="text-align: center"><img src="skins/default/img/icons/tick.png" /></div>'
		}
	},
		
	renderPriority: function(val,metadata,rec,row,col,store){
		if(val != null){
			return itasks.util.formatPriority(val.managerProps.priority);
		}
	},
	
	renderDelegated: function(val,metadata,rec,row,col,store){
		if(rec.data.finished) metadata.css += 'hide-cell-action ';
		return Ext.util.Format.htmlEncode(val);
	}
});

Ext.ns('itasks.ttc.parallel');

itasks.ttc.parallel.AssignWindow = Ext.extend(Ext.Window,{
	
	initComponent: function(){
		
		this.ucontrol = new itasks.tui.UsernameControl({
			preventMark: true,
			value: this.initUser
		});
		
		this.progress = new Ext.ProgressBar({hidden: true});
		
		Ext.apply(this,{
			title: 'Re-assign task',
			modal: true,
			resizable: false,
			items: [{
				html: 'Please select a user to whom this task may be assigned.'
			},{
				xtype: 'form',
				items: [this.ucontrol],
				buttons: [{
					text: 'Cancel',
					iconCls: 'icon-cancel',
					handler: function(b,e) { b.findParentByType(itasks.ttc.parallel.AssignWindow).close(); }
				  },{
					text: 'Ok',
					iconCls: 'icon-ok',
					handler: this.handleAssignment
				  }
				]
			},this.progress],
			defaults: {unstyled: true, bodyStyle: 'padding: 4px'}
		});
	
		itasks.ttc.parallel.AssignWindow.superclass.initComponent.apply(this,arguments);
	},
	
	handleAssignment: function(button,evt){
		
		var win = this.findParentByType(itasks.ttc.parallel.AssignWindow);
		var val = win.ucontrol.getValue();
		var c = new Ext.data.Connection();
		
		c.on('beforerequest', function(conn,options){
			win.progress.show();
			win.progress.wait({text: 'Reassigning task...'});
		},this);
		
		c.on('requestcomplete', function(conn,response,options){
			var resp = Ext.decode(response.responseText);
			
			if(!resp.success){
				Ext.Msg.alert('Error',resp.error);
			}
		
			itasks.app.mainGui.refreshGUI();	
		},this);		
		
		c.on('requestexception', function(conn,response,options){
			Ext.Msg.alert('Error', 'Cannot reassign task. The task is either non existent or you don\'t have sufficient privileges');
		});
		
		c.request({
			url: itasks.config.serviceUrl+'/json/tasks/'+win.taskId+ '/managerProperties/worker',
			params: { session: itasks.app.session, update: Ext.encode(val)},
			callback: function(){
				win.close();
			}
		});		
	}
});

Ext.reg('itasks.ttc.parallel',itasks.ttc.ParallelContainer);
Ext.reg('itasks.ttc.parallel.assign', itasks.ttc.parallel.AssignWindow);
Ext.ns('itasks.ttc')

itasks.ttc.GroupContainer = Ext.extend(Ext.Panel,{
	initComponent: function(){
		Ext.apply(this, 
		{ layout:'auto'
		, cls: 'GroupContainer'
		, autoScroll: true
		, unstyled: true
		, tbar: []
		, fixedCont: new Ext.util.MixedCollection()		// collection of all fixed containers
		, floatingCont: new Ext.util.MixedCollection()	// collection of all floating containers
		, taskUpdates : {}
		, url: itasks.config.serviceUrl + "/json/tasks/" + this.taskId + "/tui"
		});

		itasks.ttc.GroupContainer.superclass.initComponent.apply(this,arguments);
		
		for(var i=0; i < this.content.length; i++) {
			this.createContainer(this.content[i].panel,this.content[i].behaviour,this.content[i].index,false);
		}
		
		// add all fixed containers as children, floating containers are rendered in a different way
		this.fixedCont.each(function(cont) {
			this.add(cont);
		}, this);
	},
	
	createContainer: function(cont, behaviour, idx, focus) {
		var group = this;
		
		// check for behaviour stored in cookie for containers which can be (un)pinned
		if (behaviour == 'GBFixed' || behaviour == 'GBFloating')
			behaviour = Ext.state.Manager.get(this.taskId + '_' + idx + '_behaviour', behaviour);
		
		this.setupChildContainer(cont, behaviour);
		
		switch(behaviour) {
			case 'GBFixed':
			case 'GBAlwaysFixed':
				this.fixedCont.add(idx, new Ext.Panel({
					index: idx,
					cls: 'GroupFixed GroupFixedNoFocus',
					items: [cont],
					unstyled: true,
					listeners: {
						afterrender: function(p) {
							//p.el.fadeIn();
							p.el.on('mousedown', function() {
								group.focusContainer(p);
							});
							
							if(focus) {
								//p.el.frame();
								group.focusContainer(p);
							}
						}
					},
					focusFixed: function() {
						this.removeClass('GroupFixedNoFocus');
						this.doLayout();
					},
					unfocusFixed: function() {
						this.removeClass('GroupFixedNoFocus');
						this.addClass('GroupFixedNoFocus');
						this.doLayout();
					}
				}));
				break;
			default:
				if (behaviour == 'GBFloating') {
					// pin button for floating containers
					var tools = [{
						id: 'pin',
						handler: function(ev,el,window) {
							var cont = window.get(0);
							var idx = window.index;
							window.removeAll(false);
							group.floatingCont.remove(window);
							window.destroy();
							Ext.state.Manager.set(group.taskId + '_' + idx + '_behaviour', 'GBFixed');
							group.createContainer(cont, 'GBFixed', idx, true);
							if (cont.getXType() == 'itasks.ttc.form' || cont.getXType() == 'itasks.ttc.message') 
								group.showAllMenuItems(cont.getTopToolbar());
							group.renderFixed();
						}
					}];
				}
				
				var title = cont.subject;
				
				this.floatingCont.add(idx, {
					id: this.taskId + '_' + idx,
					xtype: 'window',
					index: idx,
					cls: 'GroupFloating',
					closable: false,
					autoScroll: true,
					maximizable: true,
					constrainHeader: true,
					modal: behaviour == 'GBModal',
					items: [cont],
					title: title,
					tools: tools,
					minWidth: 300,
					stateful: true,
					stateEvents: ['maximize']
				});
				break;
		}
	},
	
	setupChildContainer: function(cont,behaviour) {
		var group = this;
		if (behaviour == 'GBFixed' || behaviour == 'GBFloating') {
			// add unpin button for undockable containers, is hidden if rendered inside window
			cont.headerButton = {
				xtype:'button', unstyled: true, iconCls: 'icon-unpin', cls: 'GroupUnpinButton',
				handler: function() {
					var panel = group.focusedContainer;
					//panel.getEl().fadeOut({callback: function() {
						group.focusedContainer = null;
						var cont = panel.get(0);
						panel.removeAll(false);
						group.fixedCont.remove(panel);
						panel.destroy();

						// copy toolbar back from shared one & hide menu items referring to top group actions
						if(cont.getXType() == 'itasks.ttc.form' || cont.getXType() == 'itasks.ttc.message') {
							group.copyTbar(group.getTopToolbar(), cont.getTopToolbar());
							group.hideTopGroupActionMenuItems(cont.getTopToolbar());
						}

						// hack: remove fixed width of footer
						/*var footer = Ext.DomQuery.selectNode('.x-plain-footer', cont.getEl().dom);
						if(footer)
							Ext.DomHelper.applyStyles(footer, {width:'auto'});*/
						
						Ext.state.Manager.set(group.taskId + '_' + panel.index + '_behaviour', 'GBFloating');
						group.createContainer(cont, 'GBFloating', panel.index, false);
						group.focusFirstContainer();
						group.doLayout();
					//}});
				}
			};
		}
	},
	
	renderFixed: function() {
		// add new floating containers in order given by index
		var insertPos = 0;
		this.fixedCont.keySort();
		this.fixedCont.eachKey(function(idx,cont) {
			var pos = this.items.indexOf(cont);
			if(pos != -1) {
				insertPos = pos + 1;
			} else {
				this.insert(insertPos, cont);
				insertPos++;
			}
		}, this);
		
		this.doLayout();
	},
	
	renderFloating: function() {
		var modalDlgs = new Ext.util.MixedCollection();
		this.floatingCont.eachKey(function(idx,cont) {
			if (!cont.rendered) {
				cont.renderTo = this.getEl();
				cont = Ext.create(cont);
				
				// fix size of window
				var s = cont.getSize();
				cont.setSize(s.width > cont.minWidth ? s.width : cont.minWidth, s.height);
				//hack: make sure the ownerCt is set to reference the parent, so that findParentByType works.
				cont.ownerCt = this;
				
				if(!cont.modal)
					cont.show();
				else
					modalDlgs.add(cont);
				// put created object into collection
				this.floatingCont.replace(idx,cont);
			}
			
			// hide menu items referring to top group actions
			if(cont.get(0).getXType() == 'itasks.ttc.form' || cont.get(0).getXType() == 'itasks.ttc.message')
				this.hideTopGroupActionMenuItems(cont.get(0).getTopToolbar());
		}, this);
		
		// show modal dialogs after normal ones to make sure they are rendered in front
		modalDlgs.each(function(dlg) {
			dlg.show();
		});
	},
	
	onLayout: function() {
		itasks.ttc.GroupContainer.superclass.onLayout.call(this,arguments);
		// render windows after layouting to make sure they are positioned inside container correctly
		this.renderFloating();
		// focus first container the first time group is layouted
		if(!Ext.isDefined(this.focusedContainer))
			this.focusFirstContainer();
	},
	
	focusContainer: function(cont) {
		if(cont == this.focusedContainer)
			return; // cont already focused
			
		var oldFocused = this.focusedContainer;
		this.focusedContainer = cont;
			
		if(oldFocused) {
			oldFocused.unfocusFixed();
			
			// only copy toolbar of form and message containers
			if(oldFocused.get(0).getXType() == 'itasks.ttc.form' || oldFocused.get(0).getXType() == 'itasks.ttc.message') {
				// copy top toolbar back to container
				this.copyTbar(this.getTopToolbar(), oldFocused.get(0).getTopToolbar());
			}
		}

		// make new toolbar & focus container
		this.mkSharedTbar(cont);
		cont.focusFixed();
	},
	
	focusFirstContainer: function() {
		if (this.fixedCont.getCount() > 0) {
			this.focusContainer(this.fixedCont.itemAt(0));
		} else {
			// there is no fixed cont, create toolbar with group-actions
			this.focusedContainer = null;
			this.mkGroupAToolbar();
		}
	},
	
	mkSharedTbar: function(cont) {
		var groupTbar = this.getTopToolbar();
		groupTbar.removeAll();
		
		// only copy toolbar of form and message containers
		if (cont.get(0).getXType() == 'itasks.ttc.form' || cont.get(0).getXType() == 'itasks.ttc.message') {
			// copy top toolbar to shared group toolbar
			var taskTbar = cont.get(0).getTopToolbar();
			if(taskTbar) {
				this.copyTbar(taskTbar, groupTbar);
			}
			
			//apply the taskId to the new TB, so that attachTaskHandlers nows on which subtask the actions should
			//be applied
			groupTbar.cascade(function(){
				Ext.apply(this,{
					taskId : cont.get(0).taskId
				});
			});
			itasks.ttc.common.attachTaskHandlers(groupTbar,cont.get(0).taskId);
		}
		
		groupTbar.setVisible(groupTbar.items.length > 0);
	},
	
	mkGroupAToolbar: function() {
		var groupTbar = this.getTopToolbar();
		groupTbar.removeAll();
		groupTbar.add(this.groupAMenu);
		groupTbar.setVisible(groupTbar.items.length > 0);
		//apply the taskId to the new TB, so that attachTaskHandlers nows on which subtask the actions should
		//be applied
		groupTbar.cascade(function(){
			Ext.apply(this,{
				taskId : this.taskId
			});
		});
		itasks.ttc.common.attachTaskHandlers(groupTbar,this.taskId);
		itasks.ttc.common.setupHotkeys(groupTbar, this);
		groupTbar.doLayout();
	},
	
	copyTbar: function(src,dst) {
		var items = src.items.getRange();
		src.removeAll(false);
		dst.removeAll();
		dst.add(items);
		src.doLayout();
		dst.doLayout();
	},
	
	update: function(data) {
		var content = data.content;
		this.groupAMenu = data.groupAMenu;
		
		// make copy of old collection of containers to keep track of non-updated ones
		var oldFixed = this.fixedCont;
		this.fixedCont = new Ext.util.MixedCollection();
		var oldFloating = this.floatingCont;
		this.floatingCont = new Ext.util.MixedCollection();
		var focusFixed;
		var focusFloating = new Ext.util.MixedCollection();

		for(var i=0; i < content.length; i++) {
			if(cont = oldFixed.key(content[i].index)) {
				// update existing fixed container
				this.updateItem(cont, content[i].panel, content[i].behaviour);
				oldFixed.remove(cont);
				if (content[i].focus)
					focusFixed = cont;
			} else if(cont = oldFloating.key(content[i].index)) {
				// update existing floating container
				this.updateItem(cont, content[i].panel, content[i].behaviour);
				oldFloating.remove(cont);
				if (content[i].focus)
					focusFloating.add(cont);
			} else {
				// create new container
				this.createContainer(content[i].panel, content[i].behaviour, content[i].index);
			}
		}
		
		// destroy removed containers
		oldFixed.each(function(item) {
			if(item == this.focusedContainer)
				this.focusedContainer = null;
			item.destroy();
		}, this);
		oldFloating.each(function(item) {
			item.destroy();
		});
		
		this.renderFixed();
		
		if (this.focusedContainer) {
			var cont = this.focusedContainer.get(0);
		
			if (
				(cont.getXType() == 'itasks.ttc.form' || cont.getXType() == 'itasks.ttc.message') &&
				cont.getTopToolbar().items.length > 0
			) {
				// toolbar of focused container has been updated, copy changes to shared toolbar
				this.mkSharedTbar(this.focusedContainer);
			} 
		}
		
		// focus containers for which focus commands have been sent
		if (Ext.isDefined(focusFixed))
			this.focusContainer(focusFixed);
			
		focusFloating.each(function(c) {
			c.toFront();
		}, this);
		
		// try to focus new fixed container
		if(!this.focusedContainer)
			this.focusFirstContainer();
	},
	
	updateItem: function(old, newC, behaviour) {
		var oldC = old.get(0);
		this.setupChildContainer(newC, behaviour);
		if(oldC.getXType() == newC.xtype && oldC.taskId == newC.taskId) {
			// update container contents
			oldC.update(newC);
		} else {
			//if not same xtype or taskId - completely replace container contents
			old.removeAll();
			old.add(newC);
		}
		old.doLayout();
		// put changed container into collections
		if(old.getXType() == 'window')
			this.floatingCont.add(old.index,old);
		else
			this.fixedCont.add(old.index,old);
	},
	
	addUpdate: function(name, value) {
		if(this.focusedContainer)
			// update is handled by focused child
			this.focusedContainer.get(0).addUpdate(name, value);
		else
			// updates for groupAToolbar are handled by group container
			this.taskUpdates[name] = value;
	},
	
	sendUpdates: function(delay) {
		if(this.focusedContainer)
			// update is handled by focused child
			this.focusedContainer.get(0).sendUpdates(delay);
		else {
			// updates for groupAToolbar are handled by group container
			var wt = this.findParentByType(itasks.WorkPanel);
			if(!wt) return;
			wt.sendTaskUpdates(this.taskId,this.taskUpdates);
			this.taskUpdates = {};
		}
	},
	
	hideTopGroupActionMenuItems: function(item, options) {
		if(Ext.isBoolean(item.topGroupAction)) {
			// items is a normal menu item
			if (item.topGroupAction) {
				// hide top group actions
				item.hide();
			} else {
				// there is a non-hidden item
				// no separator has to be hidden and the menu can stay enabled
				options.hideNextSeparator = false;
				options.hideSeparatorOnEnd = false;
				options.disableMenu = false;
			}
		} else if (item.getXType() == 'menuseparator') {
			if (options.hideNextSeparator)
				// hide separator
				item.hide();
			else
				// do not hide separator at the moment,
				// but possibly later if it would be the last item of the menu
				options.hideSeparatorOnEnd = item;
				
			// no two consecutive separators
			options.hideNextSeparator = true;
		} else {
			// start of new (sub menu)
			var newOpts = {
				disableMenu: true,
				hideNextSeparator: true,
				hideSeparatorOnEnd: false
			};
				
			var children =  item.items || item.menu.items;

			for(var i = 0; i < children.length; i++) {
				this.hideTopGroupActionMenuItems(children.get(i), newOpts);
			}

			if (item.getXType() != 'toolbar') {
				// possibly hide last separator
				if (newOpts.hideSeparatorOnEnd)
					newOpts.hideSeparatorOnEnd.hide();
				
				// disable empty main and hide empty submenus
				if (newOpts.disableMenu)
					if (item.getXType() == 'button')
						item.disable();
					else
						item.hide();
			}
		}
	},
	
	showAllMenuItems: function(item) {
		if(item.name || item.getXType() == 'menuseparator') {
			// show all normal item & separators
			item.show();
		} else {
			if (item.getXType() == 'button' && item.menu.items.length == 0) {
				// disable empty main menus
				item.disable();
				return;
			} else {
				// show & enable all non-empty main and all submenus
				item.enable();
				item.show();
			}
			
			var children =  item.items || item.menu.items;
			for(var i = 0; i < children.length; i++) {
				this.showAllMenuItems(children.get(i));
			}
		}
	}
});

Ext.reg('itasks.ttc.group',itasks.ttc.GroupContainer);/**
 * Specialized window component for iTasks login
 */

Ext.ns('itasks');

itasks.LoginWindow = Ext.extend(Ext.Window, {
	
	//Initial error message
	errorMsg: "",
	
	//Initializion function
	initComponent: function() {	
		
		var submitHandler = function() {
			this.getComponent(0).getForm().submit({waitMsg: 'Validating username and password...'});
		};
		var successHandler = function(form, action) {
			//Clear the error message
			this.getComponent(0).getComponent(0).setText('');

			//Fade out the window
			this.getEl().fadeOut({
				callback: function() {
					this.continuation(action.result.session);		
				},
				scope: this
			});
		};
		var failureHandler = function(form, action) {
			//Show the error and draw attention to the window
			
			if(action.failureType == "connect") {
				this.getComponent(0).getComponent(1).setText("Could not connect to server");
			} else {
				this.getComponent(0).getComponent(1).setText(action.result.error);	
			}
			this.getEl().frame('#ff0000');

			//Focus the username
			form.findField('username').focus(true,false);
		};
		
		Ext.apply(this, {
			y: 150,
			width: 320,
			height: 185,
			layout: "fit",
			hidden: true,
			closable: false,
			resizable: false,
			shadow: false,
			items: {
				xtype: 'form',
				url: itasks.config.serviceUrl + "/json/sessions/create",
				baseCls: 'x-plain',
				style: 'padding: 5px',
				layout: 'absolute',
				defaultType: 'textfield',
				buttonAlign: 'right',
				waitMsgTarget: true,
				items: [{
							x: 0,
							y: 0,
							xtype: 'label',
							style: "background: url('skins/" + itasks.config.skin + "/img/loginwindow.png') no-repeat;" +
								   "padding-left: 65px; padding-top: 20px; font-size: 16px; font-weight: bold;",
							width: 300,
							height: 55,
							text: itasks.app.application
						},{
							x: 55,
							y: 45,
							xtype: 'label',
							html: this.errorMsg,
							style: "color: red; font-weight: bold;"
						},{
							x: 0,
							y: 70,
							xtype: 'label',
							text: 'Username:'
						},{
							x: 55,
							y: 65,
							anchor: '100%',
							name: 'username'
						},{
							x: 0,
							y: 100,
							xtype: 'label',
							text: 'Password:'
						},{
							x: 55,
							y: 95,
							anchor: '100%',
							name: 'password',
							inputType: 'password'
				}],
				buttons: [{
					text: 'Log in',
					handler: submitHandler,
					scope: this
				}]
			}
		});

		//initialize the superclass (Ext.Window)
		itasks.LoginWindow.superclass.initComponent.apply(this, arguments);
		
		var loginPanel = this.getComponent(0);
	
		//Attach the success and failure event handlers
		loginPanel.on('actioncomplete', successHandler, this);
		loginPanel.on('actionfailed', failureHandler, this);

		//Add a keymap to connect <enter> in the form to the submit action
		loginPanel.on('render', function () {
			new Ext.KeyMap(loginPanel.getEl(), {
				key: Ext.EventObject.ENTER,
				fn: submitHandler,
				scope: this
			});
		},this);
	},
	focus: function() {
		this.getComponent(0).getForm().findField('username').focus();
	},
	setError: function(msg) {
		this.getComponent(0).getComponent(1).setText(msg ? msg : "");	
	},
	continuation: function(session) {
	}
	
});
/**
* Shared base class for panels that reflect a remote server resource.
*/
Ext.ns("itasks");

itasks.RemoteDataPanel = Ext.extend(Ext.Panel, {

	url: undefined,
	params: {},
	busy: false,
	
	initComponent: function() {		
		itasks.RemoteDataPanel.superclass.initComponent.apply(this,arguments);
		this.addEvents("remoteCallStart","remoteCallEnd");
	},
	
	/*
	* Requests a remote resource
	*/
	remoteCall: function(url,params,callback) {
		if(this.busy)
			return;
			
		this.busy = true;
		this.fireEvent("remoteCallStart");
		
		//Add session id parameter
		params["session"] = itasks.app.session
		
		Ext.Ajax.request({
			method: 'POST',
			url: url,
			params: params,
			scripts: false,
			callback: function (options,success,response) {
				if(success) {
					var data;
					try {
						data = Ext.decode(response.responseText);
					} catch(SyntaxError) {
						data = response.responseText;
					}
					if(typeof data == 'object') {
						//Check for (session) errors
						if(data.error) {
							itasks.app.restart(data.error);
							return;
						}
						callback.call(this,data,true);
					} else {
						callback.call(this,response.responseText,true);
					}					
				} else {
					callback.call(this,response.error,false);
				}
				this.busy = false;
				this.fireEvent("remoteCallEnd");
			},
			scope: this
		});
	},
	/*
	* Refreshes this panel to update the remote information
	*/
	refresh: function() {
		this.remoteCall(this.url,this.params,this.update);	
	},
	/*
	* This method must be implemented to handle a refresh event
	*/
	update: function(data,success) {
	}
});

Ext.reg('itasks.remotedata',itasks.RemoteDataPanel);/**
* Panel for starting new work, used to initiate new work flows
*/
Ext.ns("itasks");

itasks.NewWorkTreeLoader = Ext.extend(Ext.tree.TreeLoader, {
	load: function (node, callback, scope) {
		this.dataUrl = "/services/json/workflows" + (node.id == "_ROOT_" ? "" : "/" + node.id);
		itasks.NewWorkTreeLoader.superclass.load.apply(this,arguments);
	},
	processResponse: function (response, node, callback, scope) {
		try {
			var o = Ext.decode(response.responseText);
			node.beginUpdate();
			for(var i = 0, len = o.workflows.length; i < len; i++ ) {
				var wf = o.workflows[i];
				var n = this.createNode({ id : wf.name
										, text: wf.label
										, iconCls: wf.folder ? "icon-folder" : "icon-workflow"
										, leaf: ! wf.folder
										, singleClickExpand: true
										});
				if(n) {
					node.appendChild(n);
				}
			}
			node.endUpdate();
			this.runCallback(callback, scope || node, [node]);
		} catch(e) {
			handleFailure(response);
		}
	}
});

itasks.NewWorkPanel = Ext.extend(Ext.tree.TreePanel ,{

	initComponent: function() {

		Ext.apply(this, {
			title: "New task...",
			iconCls: "icon-newwork",	
			loader: new itasks.NewWorkTreeLoader({
				baseParams: {session: itasks.app.session}
			}),
			root: {text: "_ROOT_", nodeType: "async", id: "_ROOT_", expanded: true},
			rootVisible: false,
			cls: "newtask-container"
		});
		itasks.NewWorkPanel.superclass.initComponent.apply(this,arguments);
		
		this.on("click", function (node, event) {
			if(node.leaf) {
				this.startWorkflow(node.id);
			}
		},this);
	},
	startWorkflow: function (workflow) {
	
		Ext.Ajax.request({
			method: "POST",
			url: "/services/json/tasks/create",
			params: {session: itasks.app.session, workflow: workflow},
			scripts: false,
			callback: this.startWorkflowCB,
			scope: this
		});
	},
	startWorkflowCB: function(el, success, response, options){
		try {
			var o = Ext.decode(response.responseText);
			this.fireEvent("processStarted",o.taskId);
		} catch(SyntaxError) {}
	}
});

Ext.reg("itasks.nwpanel", itasks.NewWorkPanel);/**
* Panel for debugging iTask workflows. Here we will put stuff such as
* task tree visualization and communication state inspection.
*/
Ext.namespace("itasks");

itasks.DebugPanel = Ext.extend(Ext.Panel, {

	worktabs: null,
	initComponent: function () {
		Ext.apply(this, {	
			title: "Debug",
			iconCls: "icon-debug",
			bodyStyle: "padding: 5px",
			deferredRender: false,
			items: [{
				xtype: "fieldset",
				title: "Overviews",
				autoHeight: true,
				items: [{
					xtype: "button",
					text: "Browse service API...",
					iconCls: "icon-services",
					style: "margin-bottom: 2px;",
					listeners: {
						click: {
							fn: function() {
								this.worktabs.openServicesTab();
							},
							scope: this	
						}
					}
				}]
			},{
				xtype: "fieldset",
				title: "Session",
				html: itasks.app.session,
				autoHeight: true,
				hideLabels: true
			}]
		});
		
		itasks.DebugPanel.superclass.initComponent.apply(this,arguments);
	}
});

Ext.reg("itasks.debug",itasks.DebugPanel);


/**
* Panel which opens the services url for debugging.
*/
Ext.ns("itasks");

itasks.ServicesPanel = Ext.extend(Ext.Panel, {

	initComponent: function () {
		Ext.apply(this, {
			title: "Services",
			closable: true,
			iconCls: "icon-services",
			html: '<iframe style="overflow:auto;width:100%;height:100%;" frameborder="0" src="' + itasks.config.serviceUrl + '/html' + '"></iframe>'
		});
		
		itasks.ServicesPanel.superclass.initComponent.apply(this, arguments);
	}
});

Ext.reg("itasks.services",itasks.ServicesPanel);/**
* This panel shows a list with work that a user has to do.
*/
Ext.ns('itasks');

itasks.WorkListPanel = Ext.extend(Ext.Panel,{ 
	initComponent: function(){

		this.treeGrid = new Ext.ux.tree.TreeGrid({
			rootVisible: false,
			border: false,
			columns: [
				{id: 'subject', header: 'Subject', dataIndex: 'subject', width: 300},
				{id: 'priority', header: 'Priority', dataIndex: 'priority', width: 100},
				{id: 'progress', header: 'Progress', dataIndex: 'progress', width: 100},
				{id: 'manager', header: 'Managed by', dataIndex: 'manager', width: 150},
				{id: 'timestamp', header: 'Date', dataIndex: 'timestamp', width: 120},
				{id: 'deadline', header: 'Deadline', dataIndex: 'deadline', width: 100}
			],
			root: new Ext.tree.TreeNode({
				text: 'Empty'
			})
		});
	
		Ext.apply(this,{
			unstyled: true,
			layout: 'fit',
			items: [this.treeGrid],	
			tbar: [{
				id: 'refreshbutton',
				xtype: 'tbbutton',
				text: 'Refresh worklist',
				iconCls: 'x-tbar-loading',
				listeners: {
					click: { 
						scope: this,
						fn: function (btn) {
							this.refresh();
						}
					}
				}	
			},'->',{
				id: 'userdisplay',
				xtype: 'label',
				text: 'Welcome ' + itasks.app.displayName
			},{
				id: 'logoutbutton',
				xtype: 'tbbutton',
				text: 'Logout',
				iconCls: 'icon-logout',
				listeners: {
					click: {
						scope: this,
						fn: function() {
							this.findParentByType(itasks.ApplicationPanel).logout();
						}	
					}
				}
			}]
		});

		itasks.WorkListPanel.superclass.initComponent.apply(this,arguments);	
		this.addEvents("workListRefreshed");
	},
	
	buildTree : function(data){		
		if(!data) return;
		
		var buildNode = function(d, isLeaf){
			
			var newCls = (d.systemProperties.firstEvent == d.systemProperties.latestEvent)?'new-task-node':''
			
			return new Ext.tree.TreeNode({
				cls: 'worklist-node '+newCls,
				uiProvider: Ext.ux.tree.TreeGridNodeUI,
				leaf: isLeaf,
				iconCls: 'task-int',
				subject: d.managerProperties.subject,
				priority: itasks.util.formatPriority(d.managerProperties.priority),
				progress: itasks.util.formatProgress(d.workerProperties.progress),
				manager: itasks.util.formatUser(d.systemProperties.manager),
				timestamp: itasks.util.formatDate(d.systemProperties.issuedAt),
				deadline: itasks.util.formatDeadline(d.managerProperties.deadline),
				taskId: d.systemProperties.taskId
			});
		}
		
		var buildSubTree = function(parent){
		
			var children = [];
			
			for(var i=0; i < treeData.length; i++){
				var d = treeData[i];
				
				if(d.systemProperties.parent == parent){					
					var childNodes = buildSubTree(d.systemProperties.taskId);	
					var node = buildNode(d, (childNodes.length > 0)?false:true);					
					treeData.splice(i,1);
					i--;
					node.appendChild(childNodes);
					children.push(node);
				}
			}	

			return children;		
		};
				
		var treeData = data;
		
		//first build top level (parent == undefined)
		var children = buildSubTree();
		
		//build all other trees
		for(var i=0; i < treeData.length; i++){
			var d = treeData[i];
			var c = buildSubTree(d.taskId);
			var n = buildNode(d, (c.length > 0)?false:true);
			n.appendChild(c);
			children.push(n);
		}
		
		this.treeGrid.getRootNode().removeAll();
		this.treeGrid.getRootNode().appendChild(children);
		this.treeGrid.expandAll();
	},
	
	refresh : function(){	
		var ct = this;
		var conn = new Ext.data.Connection();
		
		conn.request({
			url: itasks.config.serviceUrl + "/json/tasks",
			params: { session : itasks.app.session },
			callback: function(options,success,response) {
				if(!success) itasks.app.restart('Cannot retrieve work list');
				
				var data = Ext.decode(response.responseText);
				if(!data.success) itasks.app.restart(data.error);

				ct.buildTree(data.tasks);
				ct.fireEvent("workListRefreshed", ct);
			}
		});
	},
	
	markRead : function(taskId){
				
		var f = function(){
			if(this.attributes.taskId == taskId) this.ui.removeClass('new-task-node');
			return true;
		}
		
		this.treeGrid.getRootNode().cascade(f);
	}
});

Ext.reg('itasks.worklist',itasks.WorkListPanel);
/**
* Tab panel which shows a dashboard style 'home' screen.
*/

Ext.ns("itasks");

itasks.HomeTabPanel = Ext.extend(Ext.Panel, {

	initComponent: function () {
		Ext.apply(this, {
			title: "Start",
			closable: true,
			iconCls: "icon-home",
			unstyled: true,
			cls: 'homePanel',
			autoHeight: true,
			bodyCssClass: 'homePanel-body',
			//autoLoad: "skins/" + itasks.config.skin + "/welcome.html"
			html:
				'<div class="homePanel-logo"></div><div class="homePanel-text"><h1>'+itasks.app.application+'</h1>'+
				'<p>Congratulations! You are now running the <span style="font-weight: bold">'+itasks.app.application+'</span>-application.'+
				'<p>Tasks which you can start are displayed on the left of the screen. '+
				'Clicking on such a task will start it and work will be assigned to the users. On top of the screen an overview is given of all work you are requested to complete. ' +
				'Clicking on an item at the top of the screen will open a tab in this window, which allows you to fulfill the selected assignment.'+
				'<h2>Powered by iTasks</h2>'+
				'<p>This application is powered by the iTask system. This system is developed by the <a href="http://wiki.clean.cs.ru.nl" target="_blank">Clean Team</a> in '+
				'the context of several research projects on functional specifications of workflows. '+
				'<p>To keep up with the latest developments, more information can be found on the Clean Wiki: <br />'+
				'<a href="http://itasks.cs.ru.nl/" target="_blank">http://itasks.cs.ru.nl/</a>'+
				'</div>'
				
		});
		
		itasks.HomeTabPanel.superclass.initComponent.apply(this, arguments);
	}
});

Ext.reg("itasks.hometab",itasks.HomeTabPanel);/**
* Tab panel which shows a task a user is working on
*/

Ext.ns("itasks");

itasks.WorkPanel = Ext.extend(itasks.RemoteDataPanel, {

	taskId: null,
	properties: null,
	
	debug: false,
	initialized: false,
	
	initComponent: function() {
		Ext.apply(this, {
			title: "Loading task...",
			closable: true,
			autoDestroy: true,
			iconCls: "icon-task",
			url: itasks.config.serviceUrl + "/json/tasks/" + this.taskId + "/tui",
			params: {session: itasks.app.session},
			layout: "border",
			items: [{
				xtype: "itasks.work-header",
				region: "north",
				height: 25
			},{
				xtype: "panel",
				region: "center",
				layout: "anchor",
				ctCls: "worktab-container",
				bodyStyle: 'background-color: #eee',
				defaults: {
					anchor: 'bottom 0'
				},
				tbar: [{
					text: 'Task Actions',
					iconCls: 'icon-properties',
					menu: {
						id: 'taskMenu',
						items: [{
							text: 'Refresh Task',
							iconCls: 'x-tbar-loading',
							scope: this,
							handler: function(item,evt){
								this.refresh();
							}
						},{
							text: 'Task Properties'	,
							iconCls: 'icon-properties',
							scope: this,
							handler: function(item,evt){
								this.showProperties();
							}
						},{
							text: 'Discuss Task',
							iconCls: 'icon-chat',
							disabled: true
						},'-',{
							text: 'Cancel Task',
							iconCls: 'icon-trash',
							scope: this,
							handler: function(item,evt){
								this.cancel();
							}
						}]
					}					
				}]
			}]
		});
		
		itasks.WorkPanel.superclass.initComponent.apply(this, arguments);
	
		this.addEvents("taskRedundant","taskDone","propertyChanged","afterUpdateContent");
	
		//Attach tab change handler
		this.getComponent(1).on("tabchange",function(ct,tab){
			if(tab && tab.subtaskId){
				this.activeSubtaskId = tab.subtaskId;
			}
		},this);
		
		this.on("afterUpdateContent",function(){
			var me = this;
			(function(){me.doLayout(false,true)}).defer(100);
		});
		
		//Attach event handlers for the loading indicator
		this.on("remoteCallStart",function() {
			this.getComponent(0).setBusy(true);
		},this);
		this.on("remoteCallEnd",function() {
			this.getComponent(0).setBusy(false);
		},this);
	},
	update: function(data,success) {
		//Check if the task is finished or became redundant
		if(success == false || data.tui == "done" || data.tui == "redundant") {
			
			var ct = this.getComponent(1);
			
			if(ct.items && ct.items.length) {
				ct.remove(0);
			}

			if(!success || data.tui == "redundant"){
				msg = "The completion of this task is no longer required.<br />It has been removed. Thank you for your effort.";
				this.fireEvent("taskRedundant");
			}else{
				msg = "This task is completed. Thank you.";
				this.fireEvent("taskDone");
			}
			
			ct.add({
				xtype: 'itasks.ttc.finished',
				msg: msg
			});
		
			ct.doLayout();			
			
			var tp = this.findParentByType("itasks.worktabs");
			var tab = this;
			this.getEl().fadeOut(
				{ scope: this
				, duration: .75
				, useDisplay: true
				, callback: function()
					{ 
						tp.remove(tab);
					}
				}
			);
			return;
		}
		//Update properties
		this.properties = data.task;
		//Update header
		this.getComponent(0).setContent(this.taskId, data.task.managerProperties.subject, data.task);
		//Update title
		this.updateTitle(data.task.managerProperties.subject);
		//Update content
		this.updateContent(data.tui);
	},
	updateTitle: function(subject) {
		this.setTitle(Ext.util.Format.ellipsis(subject,10));
	},
	updateContent: function(content) {
		var ct = this.getComponent(1);

		if(this.initialized) {
			//Recursively update tab content
			var cur = ct.getComponent(0);
			
			if(cur.taskId == content.taskId && cur.xtype == content.xtype) {
				cur.update(content);
			} else {
				ct.remove(0,true);
				ct.add(content);
				ct.doLayout();
			}
		} else {
			//Build initial content
			ct.add(content);
			ct.doLayout();
			this.initialized = true;
		}			
	},
	sendTaskUpdates: function(target, updates) {
		//Build event list
		var events = [];
		for(var k in updates) {
			events[events.length] = [target,k,updates[k].toString()];
		}
		//Set events and refresh
		this.params["events"]	= Ext.encode(events);
		this.refresh();
	},
	updateToolbar: function(properties) {		
		var getUserName = function(name){
			if(name.match("(.+)<(.+)>"))
				return name.replace("(.+)<(.+)>", "$2");
			else
				return name;
		}
		
		var cancelMI = this.getComponent(1).getTopToolbar().getComponent(0).menu.getComponent(4);
		if(getUserName(properties.managerProperties.worker) == getUserName(properties.systemProperties.manager)){
			cancelMI.enable();
		}else{
			cancelMI.disable();
		}
	},
	cancel : function(){
		var me = this;
		
		var  doCancel = function(btn){	
			if(btn == "yes"){
				var url = itasks.config.serviceUrl + "/json/tasks/" + me.taskId + "/cancel";
				var params = {};
				var cb = function(data){
					if(data.success)
						(function(){
							me.update({},false); //send a blank update, this will mark the tab as redundant.						
						}).defer(50);
					else
						Ext.Msg.alert('Error','Failed to cancel task: '+data.error);
				};		
				me.remoteCall(url,params,cb);	
			}
		}
		
		Ext.Msg.confirm("Cancel Task","Are you sure you wish to cancel this task?",doCancel);
	},
	showProperties: function(){
		var p = this.properties;
	
		var w = new Ext.Window({
			title : 'Task Properties',
			iconCls: 'icon-properties',
			resizable: false,
			width: 500,
			height: 300,
			layout: 'accordion',
			cls: 'task-properties-window',
			defaults: {
				bodyStyle: 'padding: 10px'
			},
			layoutConfig: {
				titleCollapse: false,
				hideCollapseTool: true
			},
			items: [
				{ title: 'Runtime Properties'
				, iconCls: 'icon-currentwork'
				, layout: 'form'
				, defaultType: "staticfield"
				, items: [{
					//xtype: "itasks.progress",
					name: "progress",
					fieldLabel: "Progress",
					format: itasks.util.formatProgress,
					value: p.workerProperties.progress
					//listeners: {
					//	"change" : function(ov,nv) {var wt = this.findParentByType(itasks.WorkPanel); wt.sendPropertyEvent(wt.properties.systemProperties.taskId,"progress",nv); }
					//}
				},{
					name: "priority",
					fieldLabel: "Priority",
					format: itasks.util.formatPriority,
					value: p.managerProperties.priority
				},{
					name: "issuedAt",
					fieldLabel: "Issued at",
					format: itasks.util.formatDate,
					value: p.systemProperties.issuedAt
				},{
					name: "firstEvent",
					fieldLabel: "First worked on",
					format: itasks.util.formatStartDate,
					value: p.systemProperties.firstEvent
				},{
					name: "latestEvent",
					fieldLabel: "Last worked on",
					format: itasks.util.formatStartDate,
					value: p.systemProperties.latestEvent
				}]
				}
			]
		});
		
		w.show();
	}
});

itasks.WorkHeaderPanel = Ext.extend(Ext.Panel, {
				
	initComponent: function() {
		Ext.apply(this, {
			deferredRender: false,
			html: "Loading...",
			baseCls: "worktab-header-normal-priority"
		});
		itasks.WorkHeaderPanel.superclass.initComponent.apply(this,arguments);
		
	},
	setContent: function(taskid, subject, properties) {		
			worktabStatus = function(progress){
				switch(progress){
					case null : return "";
					case "TPActive" : return "worktab-header-progress-active";
					case "TPStuck" : return "worktab-header-progress-stuck";
					case "TPWaiting": return "worktab-header-progress-waiting";
					case "TPReject": return "worktab-header-progress-reject";
				}
			}
			
			worktabBackground = function(priority){
				switch(priority) {
					case null : return "";
					case "LowPriority":
					case "NormalPriority": return "worktab-header-normal-priority";
					case "HighPriority": return "worktab-header-high-priority";
				}		
			}
			
			var subject = subject + (itasks.config.debug ? (" (" + taskid + ")") : "");
			
			this.body.update( String.format(
				'<div class="worktab-header {1}">'+
					'<div class="worktab-header-status {0}"></div><div class="worktab-header-separator"></div><div class="worktab-header-text">'+
						'<table><tr><th>Subject:</th><td>{2}</td><th>Managed by:</th><td>{3}</td><th>Deadline:</th><td>{4}</td></table>'+
					'</div>'+
				'</div>'+
				'<div class="worktab-header-indicator">'
				, worktabStatus(properties.workerProperties.progress),worktabBackground(properties.managerProperties.priority),subject, itasks.util.formatUser(properties.systemProperties.manager)
				, itasks.util.formatDeadline(properties.managerProperties.deadline)
				));
	},
	setBusy: function(busy) {
		var indicator = this.getEl().child(".worktab-header-indicator");
		if(indicator)
			indicator.setVisible(busy);
	}	
});

Ext.reg("itasks.work",itasks.WorkPanel);
Ext.reg("itasks.work-header",itasks.WorkHeaderPanel);/**
* Tab panel which shows the result of a task
*/

Ext.ns("itasks");

//services/json/tasks/<taskId>/result/tui

itasks.ResultPanel = Ext.extend(itasks.RemoteDataPanel, {

	initComponent : function(){
		Ext.apply(this, {
			title: 'Loading result...',
			closable: true,
			autoDestroy: true,
			iconCls: 'icon-task-result',
			layout: 'border',
			url: itasks.config.serviceUrl+ "/json/tasks/" + this.taskId+ "/result/tui",
			params: {},
			items: [{
				xtype: 'itasks.result-header',
				region: 'north',
				height: 25
			},{
				xtype: 'panel',
				region: 'center',
				layout: 'anchor',
				ctCls: 'worktab-container',
				bodyStyle: 'background-color: #eee',
				defaults: { anchor: 'bottom 0' }
			}]
		});
		
		itasks.ResultPanel.superclass.initComponent.apply(this,arguments);
		
		this.on("remoteCallStart",function() { this.getComponent(0).setBusy(true); },this);
		this.on("remoteCallEnd",function() { this.getComponent(0).setBusy(false); },this);
	},
	
	update: function(data){
		var rh = this.getComponent(0);
		var rp = this.getComponent(1);
		
		var props = data.task;
		var subject = props.managerProperties.subject
				
		this.properties = props;
		this.setTitle(Ext.util.Format.ellipsis(subject,10));		
				
		rh.setContent(data.tui.taskId, subject, props);
		
		if(rp.initialized){
			rp.removeAll();
			rp.doLayout();
		}
		
		rp.add(data.tui);
		rp.doLayout();
		rp.initialized = true;
	}
});

itasks.ResultHeaderPanel = Ext.extend(Ext.Panel, {
				
	initComponent: function() {
		Ext.apply(this, {
			deferredRender: false,
			html: "Loading...",
			baseCls: "worktab-header-normal-priority"
		});
		itasks.ResultHeaderPanel.superclass.initComponent.apply(this,arguments);
		
	},
	setContent: function(taskid, subject, properties) {						
			var subject = subject + (itasks.config.debug ? (" (" + taskid + ")") : "");
			
			this.body.update( String.format(
				'<div class="worktab-header">'+
					'<div class="worktab-header-text">'+
						'<table><tr><th>Result of:</th><td>{0}</td><th>Provided by:</th><td>{1}</td></table>'+
					'</div>'+
				'</div>'+
				'<div class="worktab-header-indicator">'
				, subject, properties.managerProperties.worker
				));
	},
	setBusy: function(busy) {
		var indicator = this.getEl().child(".worktab-header-indicator");
		if(indicator)
			indicator.setVisible(busy);
	}	
});

Ext.reg("itasks.result",itasks.ResultPanel);
Ext.reg("itasks.result-header",itasks.ResultHeaderPanel);/**
* This panel will show the current work in tabs.
*/

Ext.ns("itasks");

itasks.WorkTabsPanel = Ext.extend(Ext.TabPanel, {
	
	initComponent: function() {
		Ext.apply(this,{
			activeItem: 0,
			layoutOnTabChange: true,
			items: {xtype: "itasks.hometab"},
			bodyCssClass: "worktabs-body"
		});
		
		this.addEvents("taskOpened");
		
		itasks.WorkTabsPanel.superclass.initComponent.apply(this,arguments);
	},
	openWorkTab: function (taskid) {

		//Id is prefixed with the string "worktab-"
		var id = "worktab-" + taskid;
		
		//Try to find an existing tab with the same id
		var tab = this.getComponent(id);
		var isnew = false;
		
		if(tab == undefined) {
			//Create new tab
			isnew = true;
			tab = new itasks.WorkPanel({id: id, taskId: taskid});
			
			//Add new tab
			this.add(tab);
			this.activate(tab);
			this.doLayout();
		}
		this.activate(tab);
		
		this.fireEvent("taskOpened",taskid);
				
		//Return a reference to the new tab
		return [tab,isnew];
	},
	openResultTab: function(taskid) {
		var id = "resulttab-" + taskid;
		var tab = this.getComponent(id);
		var isnew = false;
		
		if(tab == undefined){
			isnew = true;
			tab = new itasks.ResultPanel({id: id, taskId: taskid});
			
			this.add(tab);
			this.activate(tab);
			this.doLayout();
			tab.refresh();
		}else{
			this.activate(tab);
		}
		
		this.fireEvent("taskOpened", taskid);
		
		return [tab,isnew];	
	},
	openDebugTab: function() {
		var tab = this.getComponent("debugtab");
		if(tab == undefined) {
			tab = new itasks.DebugPanel({id: "debugtab", worktabs: this, closable: true});
			this.add(tab);
		}
		this.activate(tab);
		return tab;	
	},
	openServicesTab: function() {
		var tab = this.getComponent("servicestab");
		if(tab == undefined) {
			tab = new itasks.ServicesPanel({id: "servicestab", worktabs: this, closable: true});
			this.add(tab);
		}
		this.activate(tab);
		return tab;
	}
});

Ext.reg("itasks.worktabs",itasks.WorkTabsPanel);/**
* Main iTasks user interface
*/
Ext.ns('itasks');

itasks.ApplicationPanel = Ext.extend(Ext.Panel, {

	initComponent: function() {

		Ext.apply(this, {
			id: 'apppanel',
			layout: 'border',
			hidden: true,
			hideMode: 'offsets',
			unstyled: true,
			items: [{
					id: 'leftpanel',
					xtype: 'itasks.nwpanel',
					region: 'west',
					layoutConfig: {animate: true},
					collapsible: true,
					collapseMode: 'mini',
					split: true,
					border: false,
					deferredRender: false,
					width: 200,
					minWidth: 200,
					maxWidth: 400,
					autoScroll: true
				},{
					id: 'centerpanel',
					region: 'center',
					xtype: 'panel',
					layout: 'border',
					border: false,
					deferredRender: false,
					items: [ {
						id: 'worklist',
						xtype: 'itasks.worklist',
						region: 'north',
						collapsible: true,
						collapseMode: 'mini',
						header: false,
						split: true,
						height: 150
					},{
						id: 'worktabs',
						xtype: 'itasks.worktabs',
						border: false,
						region: 'center'
					}]
				}]
		});
	
		itasks.ApplicationPanel.superclass.initComponent.apply(this, arguments);
	},
	afterRender: function () {
		itasks.ApplicationPanel.superclass.afterRender.apply(this, arguments);
		
		//Initializing the gui...
		var newpanel 	= this.getComponent('leftpanel');
		var worklist 	= this.getComponent('centerpanel').getComponent('worklist');
		var worktabs 	= this.getComponent('centerpanel').getComponent('worktabs');
	
		//Refresh initial overviews
		worklist.refresh();
		
		//Connect event handlers
		var attachTabHandlers = function(tab) {
			if(tab[1]) { //The tab is new
				tab[0].on("taskDone",function(taskid) {
					worklist.refresh();
				});
				tab[0].on("taskRedundant",function(taskid) {
					worklist.refresh();
				});
				tab[0].on("propertyChanged",function(taskid) {
					worklist.refresh();
				});
			}
			tab[0].refresh();
		};
		
		worklist.treeGrid.on("click", function(node,evt) {		
			attachTabHandlers(worktabs.openWorkTab(node.attributes.taskId));			
		});
		
		worklist.on("workListRefreshed",function(worklist) {
			var f = function(node){
				if(!node.attributes.taskId) return true;
				
				var tab = worktabs.getComponent("worktab-"+node.attributes.taskId);
				var wlTStamp = node.attributes.latestExtEvent
				
				if(tab != null){
					//var tTStamp = tab.properties.systemProperties.latestEvent || tab.systemProperties.latestEvent;
					//if(wlTStamp > tTStamp) tab.refresh();
					tab.refresh(); //TODO: Fix props!
				}
				
				return true;
			}

			worklist.treeGrid.getRootNode().cascade(f);
		});
		
		newpanel.on("processStarted",function(taskid) {
			//When new work is started, refresh the worklist
			//and immediately open a tab for the work
			attachTabHandlers(worktabs.openWorkTab(taskid));
			worklist.refresh();
		},this);
		
		//Mark a task as read when it is opened
		worktabs.on("taskOpened",worklist.markRead, worklist);
	
		//Add debug button
		if(itasks.config.debug) {
		
			var tb = worklist.getTopToolbar()
			var button = {
				xtype: "tbbutton",
				text: "Debug...",
				iconCls: "icon-debug",
				listeners: {
					click: {
						fn: function() {
							worktabs.openDebugTab();
						},
						scope: this
					}
				}
			};
			tb.add(button);
		}
	},
	logout: function() {	
		//Send logout request to the server
		Ext.Ajax.request({
			url: "/services/json/sessions/" + itasks.app.session + "/delete",
			scripts: false,
			callback: function () {
				//On return, restart the app
				itasks.app.restart();
			},
			scope: this
		});
	},
	refreshGUI: function(){
		//Refresh the worklist and the active tab
		var worklist 	= this.getComponent('centerpanel').getComponent('worklist');
		var worktabs 	= this.getComponent('centerpanel').getComponent('worktabs');
		var tab = worktabs.getActiveTab();
		
		
		worklist.refresh();
		tab.refresh();
	}
});/**
* Main application
*/
Ext.ns('itasks');

itasks.Application = function () {
	return {
		//Application-wide state
		session: null,
		displayName: null,
		googleMapsState: 'unloaded',
		waitingForGoogleMaps: new Ext.util.MixedCollection(true),
		scrollbarWidth: 0,
		
		viewport: new Ext.Viewport({
			layout: 'card',
			activeItem: 0,
			unstyled: true,
			items: {
				baseCls: 'bg',
				xtype: 'panel'
			}	
		}),
		
		loginWindow: null,
		mainGui: null,
		/**
		* Starts the client GUI framework
		*/
		start: function(errorMsg) {
			//Store message
			this.errorMsg = errorMsg;
			
			//Set cookie provider
			Ext.state.Manager.setProvider(new Ext.state.CookieProvider({
				expires: new Date(new Date().getTime()+(1000*60*60*24*30)), // 30 days from now
			}));
			
			//Load application information
			this.loadAppInfo();
		},
		loadAppInfo: function() {
			Ext.Ajax.request({url: itasks.config.serviceUrl + "/json/application",success: this.continueAppInfo, scope: this});
		},
		continueAppInfo: function(response) {
			Ext.apply(this,Ext.decode(response.responseText));
			
			//Load skin
			this.loadSkin();
			
			//Create the login window
			this.loginWindow = new itasks.LoginWindow({
				errorMsg: this.errorMsg,
				continuation:  this.loadUserInterface.createDelegate(this)
			});
			this.viewport.getComponent(0).add(this.loginWindow);
			this.loginWindow.show();
		},
		loadSkin: function() {
			if(this.skinLoaded) return;
			
			var link = document.createElement("link");
			link.rel = "stylesheet";
			link.type = "text/css";
			link.href = "skins/" + itasks.config.skin + "/main.css";
			
			document.body.appendChild(link);
			document.title = itasks.app.application;
			
			this.skinLoaded = true;
		},	
		/**
		* Loads and builds the GUI
		*/	
		loadUserInterface: function(session) {
			
			//Update global state
			this.session = session.sessionId;
			this.displayName = itasks.util.formatUser(session.user);
			this.scrollbarWidth = itasks.util.getScrollerWidth();
			
			//Remove the login window
			//this.loginWindow.hide();
			this.loginWindow.destroy();
			delete this.loginWindow;
		
		
			var startPanel = this.viewport.getComponent(0);
		
			this.mainGui = new itasks.ApplicationPanel();
			
			this.viewport.add(this.mainGui);
			this.viewport.layout.setActiveItem(1);
			this.viewport.doLayout();
		},
		/**
		* Resets the main viewport to show the start screen
		*/
		reset: function() {
			this.viewport.layout.setActiveItem(0);
			this.viewport.remove(1,true);
			
			//Clear the old loginwindow
			if(this.loginWindow) {
				this.loginWindow.destroy();
				delete this.loginWindow;
			}
		},
		restart: function (errorMsg) {
			this.reset();
			this.start(errorMsg);
		}
	}
};Ext.ns("itasks");

itasks.GMapPanel = Ext.extend( Ext.Panel, {

	initComponent : function(){
		
		Ext.applyIf(this,
			{ url: "/handlers/work/tab"
			, border: false
			, autoHeight: false
			, scope: this
			, displayedMarkers : new Array()
			});

		itasks.GMapPanel.superclass.initComponent.apply(this,arguments);
		this.show();
	},
	
	setValue : function(_data){
		var data = Ext.decode(_data);
		
		if(this.getWidth() != data.width || this.getHeight() != data.height) {
			this.setSize(data.width, data.height);
			this.buildMap();
		}
		this.gmap.setOptions(this.getOptions(data));
		this.markers = data.markers;
		this.addMarkers();
	},
	
	getMapType : function (mapType){
		return eval("google.maps.MapTypeId."+mapType);
	},
	
	getOptions : function(data) {
		var options = data.options;
		options.center = new google.maps.LatLng(data.center[0],data.center[1]);
		options.mapTypeId = this.getMapType(data.mapType);
		return options;
	},
	
	buildMap : function(){
		this.gmap = new google.maps.Map(this.body.dom, this.getOptions(this));

		this.addMarkers();
		
		var parent = this;
		
		var mvcEventHandler = function(){
			var ll = parent.gmap.getCenter();
			var zm = parent.gmap.getZoom();
			
			var value = {
				center : [ll.lat(),ll.lng()],
				zoom   : zm,
				type   : parent.gmap.getMapTypeId().toUpperCase()
			}
			
			var ct = parent.findParentByType(itasks.ttc.FormContainer);
			if(!ct) return;
			
			ct.addUpdate(parent.name, Ext.encode(value));
			ct.sendUpdates();
		}
		
		var lclickEventHandler = function(event){
			var ll = event.latLng
			
			var value = {
				event 	: "LEFTCLICK",
				source 	: "MAP",
				point	: [ll.lat(),ll.lng()]
			}
			
			var ct = parent.findParentByType(itasks.ttc.FormContainer);
			if(!ct) return;
			
			ct.addUpdate(parent.name, Ext.encode(value));
			ct.sendUpdates();			
		}
				
		if(this.editor){
			google.maps.event.addListener(this.gmap, 'maptypeid_changed', mvcEventHandler);
			google.maps.event.addListener(this.gmap, 'dragend', mvcEventHandler);
			google.maps.event.addListener(this.gmap, 'zoom_changed', mvcEventHandler);
			google.maps.event.addListener(this.gmap, 'click', lclickEventHandler);
		}
	},
	
	afterRender : function(){
		itasks.GMapPanel.superclass.afterRender.call(this);
		
		switch(itasks.app.googleMapsState) {
			case 'loaded':
				this.buildMap();
				break;
			case 'unloaded':
				itasks.app.googleMapsState = 'loading';
				Ext.Ajax.remoteRequest({
					url : 'http://maps.google.com/maps/api/js',
					method : 'GET',
					scriptTag: true,
					params : {
						sensor : false
					},
					success : function(response){
						itasks.app.googleMapsState = 'loaded';
						itasks.app.waitingForGoogleMaps.each(function(build){build();});
					},
					failure : function(response){
						itasks.app.googleMapsState = 'unloaded';
						Ext.Msg.alert('Failed to load Google maps API');
					}
				});
			case 'loading':
				itasks.app.waitingForGoogleMaps.addAll([this.buildMap.createDelegate(this)]);
		}
	},
	
	addMarkers : function (){
		var i=0;
		for(i=0; i<this.displayedMarkers.length; i++){
			this.displayedMarkers[i].setMap(null);
		}
		
		this.displayedMarkers = new Array();
		
		for(i=0; i<this.markers.length; i++){
						
			var markerObj = new google.maps.Marker({
				map : this.gmap,
				position : new google.maps.LatLng(this.markers[i].position[0],this.markers[i].position[1])
			});	

			this.displayedMarkers[i] = markerObj;
		}		
	}
});

Ext.reg('itasks.gmappanel', itasks.GMapPanel);Ext.ns("itasks");

itasks.GStaticMapPanel = Ext.extend( Ext.Panel, {

	initComponent : function(){
		
		Ext.apply(this,
			{ border: false
			, autoHeight: false
			, html: '<img src="'+this.url+'" width="'+this.width+'" height="'+this.height+'">'
			});

		itasks.GMapPanel.superclass.initComponent.apply(this,arguments);
		
		this.show();
	}
});

Ext.reg('itasks.gstaticmappanel', itasks.GStaticMapPanel);Ext.ns("itasks");

Ext.QuickTips.init();

Ext.onReady(function(){
	itasks.app = new itasks.Application();
	itasks.app.start();
});
